p!ranha?
Server IP : 103.169.32.36  /  Your IP : 216.73.216.187
Web Server : Apache
System : Linux web.dpmptsp 3.10.0-1160.119.1.el7.x86_64 #1 SMP Tue Jun 4 14:43:51 UTC 2024 x86_64
User : apache ( 48)
PHP Version : 5.6.40
Disable Function : NONE
MySQL : ON  |  cURL : ON  |  WGET : ON  |  Perl : ON  |  Python : ON  |  Sudo : ON  |  Pkexec : ON
Directory :  /bin/

Upload File :
Curr3nt_D!r [ Writeable ] D0cum3nt_r0Ot [ Writeable ]

 
Command :
Current File : /bin/dracut
#!/bin/bash
# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
# ex: ts=8 sw=4 sts=4 et filetype=sh
#
# Generator script for a dracut initramfs
# Tries to retain some degree of compatibility with the command line
# of the various mkinitrd implementations out there
#

# Copyright 2005-2013 Red Hat, Inc.  All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

unset BASH_ENV

# store for logging
dracut_args=( "$@" )

set -o pipefail

usage() {
    [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
    if [[ -f $dracutbasedir/dracut-version.sh ]]; then
        . $dracutbasedir/dracut-version.sh
    fi

#                                                       80x25 linebreak here ^
    cat << EOF
Usage: $0 [OPTION]... [<initramfs> [<kernel-version>]]

Version: $DRACUT_VERSION

Creates initial ramdisk images for preloading modules

  -h, --help  Display all options

If a [LIST] has multiple arguments, then you have to put these in quotes.

For example:

    # dracut --add-drivers "module1 module2"  ...

EOF
}

long_usage() {
    [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
    if [[ -f $dracutbasedir/dracut-version.sh ]]; then
        . $dracutbasedir/dracut-version.sh
    fi

#                                                       80x25 linebreak here ^
    cat << EOF
Usage: $0 [OPTION]... [<initramfs> [<kernel-version>]]

Version: $DRACUT_VERSION

Creates initial ramdisk images for preloading modules

  --kver [VERSION]      Set kernel version to [VERSION].
  -f, --force           Overwrite existing initramfs file.
  -a, --add [LIST]      Add a space-separated list of dracut modules.
  --rebuild         Append arguments to those of existing image and rebuild
  -m, --modules [LIST]  Specify a space-separated list of dracut modules to
                         call when building the initramfs. Modules are located
                         in /usr/lib/dracut/modules.d.
  -o, --omit [LIST]     Omit a space-separated list of dracut modules.
  --force-add [LIST]    Force to add a space-separated list of dracut modules
                         to the default set of modules, when -H is specified.
  -d, --drivers [LIST]  Specify a space-separated list of kernel modules to
                         exclusively include in the initramfs.
  --add-drivers [LIST]  Specify a space-separated list of kernel
                         modules to add to the initramfs.
  --force-drivers [LIST] Specify a space-separated list of kernel
                         modules to add to the initramfs and make sure they
                         are tried to be loaded via modprobe same as passing
                         rd.driver.pre=DRIVER kernel parameter.
  --omit-drivers [LIST] Specify a space-separated list of kernel
                         modules not to add to the initramfs.
  --filesystems [LIST]  Specify a space-separated list of kernel filesystem
                         modules to exclusively include in the generic
                         initramfs.
  -k, --kmoddir [DIR]   Specify the directory, where to look for kernel
                         modules
  --fwdir [DIR]         Specify additional directories, where to look for
                         firmwares, separated by :
  --kernel-only         Only install kernel drivers and firmware files
  --no-kernel           Do not install kernel drivers and firmware files
  --print-cmdline       Print the kernel command line for the given disk layout
  --early-microcode     Combine early microcode with ramdisk
  --no-early-microcode  Do not combine early microcode with ramdisk
  --kernel-cmdline [PARAMETERS] Specify default kernel command line parameters
  --strip               Strip binaries in the initramfs
  --nostrip             Do not strip binaries in the initramfs
  --prelink             Prelink binaries in the initramfs
  --noprelink           Do not prelink binaries in the initramfs
  --hardlink            Hardlink files in the initramfs
  --nohardlink          Do not hardlink files in the initramfs
  --prefix [DIR]        Prefix initramfs files with [DIR]
  --noprefix            Do not prefix initramfs files
  --mdadmconf           Include local /etc/mdadm.conf
  --nomdadmconf         Do not include local /etc/mdadm.conf
  --lvmconf             Include local /etc/lvm/lvm.conf
  --nolvmconf           Do not include local /etc/lvm/lvm.conf
  --fscks [LIST]        Add a space-separated list of fsck helpers.
  --nofscks             Inhibit installation of any fsck helpers.
  --ro-mnt              Mount / and /usr read-only by default.
  -h, --help            This message
  --debug               Output debug information of the build process
  --profile             Output profile information of the build process
  -L, --stdlog [0-6]    Specify logging level (to standard error)
                         0 - suppress any messages
                         1 - only fatal errors
                         2 - all errors
                         3 - warnings
                         4 - info
                         5 - debug info (here starts lots of output)
                         6 - trace info (and even more)
  -v, --verbose         Increase verbosity level
  -q, --quiet           Decrease verbosity level
  -c, --conf [FILE]     Specify configuration file to use.
                         Default: /etc/dracut.conf
  --confdir [DIR]       Specify configuration directory to use *.conf files
                         from. Default: /etc/dracut.conf.d
  --tmpdir [DIR]        Temporary directory to be used instead of default
                         /var/tmp.
  -l, --local           Local mode. Use modules from the current working
                         directory instead of the system-wide installed in
                         /usr/lib/dracut/modules.d.
                         Useful when running dracut from a git checkout.
  -H, --hostonly        Host-Only mode: Install only what is needed for
                        booting the local host instead of a generic host.
  -N, --no-hostonly     Disables Host-Only mode
  --hostonly-mode <mode>
                        Specify the hostonly mode to use. <mode> could be
                        one of "sloppy" or "strict". "sloppy" mode is used
                        by default.
                        In "sloppy" hostonly mode, extra drivers and modules
                        will be installed, so minor hardware change won't make
                        the image unbootable (eg. changed keyboard), and the
                        image is still portable among similar hosts.
                        With "strict" mode enabled, anything not necessary
                        for booting the local host in its current state will
                        not be included, and modules may do some extra job
                        to save more space. Minor change of hardware or
                        environment could make the image unbootable.
                        DO NOT use "strict" mode unless you know what you
                        are doing.
  --hostonly-cmdline    Store kernel command line arguments needed
                        in the initramfs
  --no-hostonly-cmdline Do not store kernel command line arguments needed
                        in the initramfs
  --no-hostonly-default-device
                        Do not generate implicit host devices like root,
                        swap, fstab, etc. Use "--mount" or "--add-device"
                        to explicitly add devices as needed.
  --hostonly-i18n       Install only needed keyboard and font files according
                        to the host configuration (default).
  --no-hostonly-i18n    Install all keyboard and font files available.
  --persistent-policy [POLICY]
                        Use [POLICY] to address disks and partitions.
                        POLICY can be any directory name found in /dev/disk.
                        E.g. "by-uuid", "by-label"
  --fstab               Use /etc/fstab to determine the root device.
  --add-fstab [FILE]    Add file to the initramfs fstab
  --mount "[DEV] [MP] [FSTYPE] [FSOPTS]"
                        Mount device [DEV] on mountpoint [MP] with filesystem
                        [FSTYPE] and options [FSOPTS] in the initramfs
  --add-device "[DEV]"  Bring up [DEV] in initramfs
  -i, --include [SOURCE] [TARGET]
                        Include the files in the SOURCE directory into the
                         Target directory in the final initramfs.
                        If SOURCE is a file, it will be installed to TARGET
                         in the final initramfs.
  -I, --install [LIST]  Install the space separated list of files into the
                         initramfs.
  --install-optional [LIST]  Install the space separated list of files into the
                         initramfs, if they exist.
  --gzip                Compress the generated initramfs using gzip.
                         This will be done by default, unless another
                         compression option or --no-compress is passed.
  --bzip2               Compress the generated initramfs using bzip2.
                         Make sure your kernel has bzip2 decompression support
                         compiled in, otherwise you will not be able to boot.
  --lzma                Compress the generated initramfs using lzma.
                         Make sure your kernel has lzma support compiled in,
                         otherwise you will not be able to boot.
  --xz                  Compress the generated initramfs using xz.
                         Make sure that your kernel has xz support compiled
                         in, otherwise you will not be able to boot.
  --lzo                  Compress the generated initramfs using lzop.
                         Make sure that your kernel has lzo support compiled
                         in, otherwise you will not be able to boot.
  --lz4                  Compress the generated initramfs using lz4.
                         Make sure that your kernel has lz4 support compiled
                         in, otherwise you will not be able to boot.
  --compress [COMPRESSION] Compress the generated initramfs with the
                         passed compression program.  Make sure your kernel
                         knows how to decompress the generated initramfs,
                         otherwise you will not be able to boot.
  --no-compress         Do not compress the generated initramfs.  This will
                         override any other compression options.
  --list-modules        List all available dracut modules.
  -M, --show-modules    Print included module's name to standard output during
                         build.
  --keep                Keep the temporary initramfs for debugging purposes
  --printsize           Print out the module install size
  --sshkey [SSHKEY]     Add ssh key to initramfs (use with ssh-client module)
  --logfile [FILE]      Logfile to use (overrides configuration setting)

If [LIST] has multiple arguments, then you have to put these in quotes.

For example:

    # dracut --add-drivers "module1 module2"  ...

EOF
}

# function push()
# push values to a stack
# $1 = stack variable
# $2.. values
# example:
# push stack 1 2 "3 4"
push() {
    local _i
    local __stack=$1; shift
    for _i in "$@"; do
        eval ${__stack}'[${#'${__stack}'[@]}]="$_i"'
    done
}

# function pop()
# pops the last value from a stack
# assigns value to second argument variable
# or echo to stdout, if no second argument
# $1 = stack variable
# $2 = optional variable to store the value
# example:
# pop stack val
# val=$(pop stack)
pop() {
    local __stack=$1; shift
    local __resultvar=$1
    local _value;
    # check for empty stack
    eval '[[ ${#'${__stack}'[@]} -eq 0 ]] && return 1'

    eval _value='${'${__stack}'[${#'${__stack}'[@]}-1]}'

    if [[ "$__resultvar" ]]; then
        eval $__resultvar="'$_value'"
    else
        printf "%s" "$_value"
    fi
    eval unset ${__stack}'[${#'${__stack}'[@]}-1]'
    return 0
}

# Little helper function for reading args from the commandline.
# it automatically handles -a b and -a=b variants, and returns 1 if
# we need to shift $3.
read_arg() {
    # $1 = arg name
    # $2 = arg value
    # $3 = arg parameter
    local rematch='^[^=]*=(.*)$'
    if [[ $2 =~ $rematch ]]; then
        read "$1" <<< "${BASH_REMATCH[1]}"
    else
        read "$1" <<< "$3"
        # There is no way to shift our callers args, so
        # return 1 to indicate they should do it instead.
        return 1
    fi
}

dropindirs_sort()
{
    local suffix=$1; shift
    local -a files
    local f d

    for d in "$@"; do
        for i in "$d/"*"$suffix"; do
            if [[ -e "$i" ]]; then
                printf "%s\n" "${i##*/}"
            fi
        done
    done | sort -Vu | {
        readarray -t files

        for f in "${files[@]}"; do
            for d in "$@"; do
                if [[ -e "$d/$f" ]]; then
                    printf "%s\n" "$d/$f"
                    continue 2
                fi
            done
        done
    }
}

rearrange_params()
{
    # Workaround -i, --include taking 2 arguments
    set -- "${@/--include/++include}"

    # This prevents any long argument ending with "-i"
    # -i, like --opt-i but I think we can just prevent that
    set -- "${@/%-i/++include}"

    TEMP=$(unset POSIXLY_CORRECT; getopt \
        -o "a:m:o:d:I:k:c:L:fvqlHhMN" \
        --long kver: \
        --long add: \
        --long force-add: \
        --long add-drivers: \
        --long force-drivers: \
        --long omit-drivers: \
        --long modules: \
        --long omit: \
        --long drivers: \
        --long filesystems: \
        --long install: \
        --long install-optional: \
        --long fwdir: \
        --long libdirs: \
        --long fscks: \
        --long add-fstab: \
        --long mount: \
        --long device: \
        --long add-device: \
        --long nofscks: \
        --long ro-mnt \
        --long kmoddir: \
        --long conf: \
        --long confdir: \
        --long tmpdir: \
        --long stdlog: \
        --long compress: \
        --long prefix: \
        --long rebuild: \
        --long force \
        --long kernel-only \
        --long no-kernel \
        --long print-cmdline \
        --long kernel-cmdline: \
        --long strip \
        --long nostrip \
        --long prelink \
        --long noprelink \
        --long hardlink \
        --long nohardlink \
        --long noprefix \
        --long mdadmconf \
        --long nomdadmconf \
        --long lvmconf \
        --long nolvmconf \
        --long debug \
        --long profile \
        --long sshkey: \
        --long logfile: \
        --long verbose \
        --long quiet \
        --long local \
        --long hostonly \
        --long host-only \
        --long no-hostonly \
        --long no-host-only \
        --long hostonly-mode: \
        --long hostonly-cmdline \
        --long no-hostonly-cmdline \
        --long no-hostonly-default-device \
        --long persistent-policy: \
        --long fstab \
        --long help \
        --long bzip2 \
        --long lzma \
        --long xz \
        --long lzo \
        --long lz4 \
        --long no-compress \
        --long gzip \
        --long list-modules \
        --long show-modules \
        --long keep \
        --long printsize \
        --long regenerate-all \
        --long noimageifnotneeded \
        --long early-microcode \
        --long no-early-microcode \
        --long no-hostonly-i18n \
        --long hostonly-i18n \
        -- "$@")

    if (( $? != 0 )); then
        usage
        exit 1
    fi
}

verbosity_mod_l=0
unset kernel
unset outfile

rearrange_params "$@"
eval set -- "$TEMP"

# parse command line args to check if '--rebuild' option is present
unset append_args_l
unset rebuild_file
while :
do
	if [ "$1" == "--" ]; then
	    shift; break
	fi
	if [ "$1" == "--rebuild" ]; then
	    append_args_l="yes"
            rebuild_file=$2
            if [ ! -e $rebuild_file ]; then
                echo "Image file '$rebuild_file', for rebuild, does not exist!"
                exit 1
            fi
            abs_rebuild_file=$(readlink -f "$rebuild_file") && rebuild_file="$abs_rebuild_file"
	    shift; continue
	fi
	shift
done

# get output file name and kernel version from command line arguments
while (($# > 0)); do
    case ${1%%=*} in
        ++include)
            shift 2;;
        *)
            if ! [[ ${outfile+x} ]]; then
                outfile=$1
            elif ! [[ ${kernel+x} ]]; then
                kernel=$1
            else
                printf "\nUnknown arguments: %s\n\n" "$*" >&2
                usage; exit 1;
            fi
            ;;
    esac
    shift
done

# extract input image file provided with rebuild option to get previous parameters, if any
if [[ $append_args_l == "yes" ]]; then
    unset rebuild_param

    # determine resultant file
    if ! [[ $outfile ]]; then
        outfile=$rebuild_file
    fi

    if ! rebuild_param=$(lsinitrd $rebuild_file '*lib/dracut/build-parameter.txt'); then
        echo "Image '$rebuild_file' has no rebuild information stored"
        exit 1
    fi

    # prepend previous parameters to current command line args
    if [[ $rebuild_param ]]; then
        TEMP="$rebuild_param $TEMP"
        eval set -- "$TEMP"
        rearrange_params "$@"
    fi

    # clean the temporarily used scratch-pad directory
    rm -rf $scratch_dir
fi

unset PARMS_TO_STORE
PARMS_TO_STORE=""

eval set -- "$TEMP"

while :; do
    if [ $1 != "--" ] && [ $1 != "--rebuild" ]; then
        PARMS_TO_STORE+=" $1";
    fi
    case $1 in
        --kver)        kernel="$2";                    PARMS_TO_STORE+=" '$2'"; shift;;
        -a|--add)      push add_dracutmodules_l  "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --force-add)   push force_add_dracutmodules_l  "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --add-drivers) push add_drivers_l        "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --force-drivers) push force_drivers_l    "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --omit-drivers) push omit_drivers_l      "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        -m|--modules)  push dracutmodules_l      "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        -o|--omit)     push omit_dracutmodules_l "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        -d|--drivers)  push drivers_l            "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --filesystems) push filesystems_l        "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        -I|--install)  push install_items_l      "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --install-optional)
                       push install_optional_items_l \
                                                 "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --fwdir)       push fw_dir_l             "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --libdirs)     push libdirs_l            "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --fscks)       push fscks_l              "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --add-fstab)   push add_fstab_l          "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --mount)       push fstab_lines          "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --add-device|--device)
                       push add_device_l         "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --kernel-cmdline) push kernel_cmdline_l  "$2"; PARMS_TO_STORE+=" '$2'"; shift;;
        --nofscks)     nofscks_l="yes";;
        --ro-mnt)      ro_mnt_l="yes";;
        -k|--kmoddir)  drivers_dir_l="$2";             PARMS_TO_STORE+=" '$2'"; shift;;
        -c|--conf)     conffile="$2";                  PARMS_TO_STORE+=" '$2'"; shift;;
        --confdir)     confdir="$2";                   PARMS_TO_STORE+=" '$2'"; shift;;
        --tmpdir)      tmpdir_l="$2";                  PARMS_TO_STORE+=" '$2'"; shift;;
        -L|--stdlog)   stdloglvl_l="$2";               PARMS_TO_STORE+=" '$2'"; shift;;
        --compress)    compress_l="$2";                PARMS_TO_STORE+=" '$2'"; shift;;
        --prefix)      prefix_l="$2";                  PARMS_TO_STORE+=" '$2'"; shift;;
        --rebuild)     if [ $rebuild_file == $outfile ]; then
                           force=yes
                       fi
                       shift
                       ;;
        -f|--force)    force=yes;;
        --kernel-only) kernel_only="yes"; no_kernel="no";;
        --no-kernel)   kernel_only="no"; no_kernel="yes";;
        --print-cmdline)
                       print_cmdline="yes"; hostonly_l="yes"; kernel_only="yes"; no_kernel="yes";;
        --early-microcode)
                       early_microcode_l="yes";;
        --no-early-microcode)
                       early_microcode_l="no";;
        --strip)       do_strip_l="yes";;
        --nostrip)     do_strip_l="no";;
        --prelink)     do_prelink_l="yes";;
        --noprelink)   do_prelink_l="no";;
        --hardlink)    do_hardlink_l="yes";;
        --nohardlink)  do_hardlink_l="no";;
        --noprefix)    prefix_l="/";;
        --mdadmconf)   mdadmconf_l="yes";;
        --nomdadmconf) mdadmconf_l="no";;
        --lvmconf)     lvmconf_l="yes";;
        --nolvmconf)   lvmconf_l="no";;
        --debug)       debug="yes";;
        --profile)     profile="yes";;
        --sshkey)      sshkey="$2";                    PARMS_TO_STORE+=" '$2'"; shift;;
        --logfile)     logfile_l="$2"; shift;;
        -v|--verbose)  ((verbosity_mod_l++));;
        -q|--quiet)    ((verbosity_mod_l--));;
        -l|--local)
                       allowlocal="yes"
                       [[ -f "$(readlink -f "${0%/*}")/dracut-init.sh" ]] \
                           && dracutbasedir="$(readlink -f "${0%/*}")"
                       ;;
        -H|--hostonly|--host-only)
                       hostonly_l="yes" ;;
        -N|--no-hostonly|--no-host-only)
                       hostonly_l="no" ;;
        --hostonly-mode)
                       hostonly_mode_l="$2";           PARMS_TO_STORE+=" '$2'"; shift;;
        --hostonly-cmdline)
                       hostonly_cmdline_l="yes" ;;
        --hostonly-i18n)
                       i18n_install_all_l="no" ;;
        --no-hostonly-i18n)
                       i18n_install_all_l="yes" ;;
        --no-hostonly-cmdline)
                       hostonly_cmdline_l="no" ;;
        --no-hostonly-default-device)
                       hostonly_default_device="no" ;;
        --persistent-policy)
                       persistent_policy_l="$2";       PARMS_TO_STORE+=" '$2'"; shift;;
        --fstab)       use_fstab_l="yes" ;;
        -h|--help)     long_usage; exit 1 ;;
        -i|--include)  push include_src "$2";          PARMS_TO_STORE+=" '$2'";
                       shift;;
        --bzip2)       compress_l="bzip2";;
        --lzma)        compress_l="lzma";;
        --xz)          compress_l="xz";;
        --lzo)         compress_l="lzo";;
        --lz4)         compress_l="lz4";;
        --no-compress) _no_compress_l="cat";;
        --gzip)        compress_l="gzip";;
        --list-modules) do_list="yes";;
        -M|--show-modules)
                       show_modules_l="yes"
                       ;;
        --keep)        keep="yes";;
        --printsize)   printsize="yes";;
        --regenerate-all) regenerate_all="yes";;
        --noimageifnotneeded) noimageifnotneeded="yes";;

        --) shift; break;;

        *)  # should not even reach this point
            printf "\n!Unknown option: '%s'\n\n" "$1" >&2; usage; exit 1;;
    esac
    shift
done

# getopt cannot handle multiple arguments, so just handle "-I,--include"
# the old fashioned way

while (($# > 0)); do
    if [ ${1%%=*} == "++include" ]; then
        push include_src "$2"
        push include_target "$3"
        PARMS_TO_STORE+=" --include '$2' '$3'"
        shift 2
    fi
    shift
done

if [[ $regenerate_all == "yes" ]]; then
    ret=0
    if [[ $kernel ]]; then
        printf -- "--regenerate-all cannot be called with a kernel version\n" >&2
        exit 1
    fi

    if [[ $outfile ]]; then
        printf -- "--regenerate-all cannot be called with a image file\n" >&2
        exit 1
    fi

    ((len=${#dracut_args[@]}))
    for ((i=0; i < len; i++)); do
        [[ ${dracut_args[$i]} == "--regenerate-all" ]] && \
            unset dracut_args[$i]
    done

    cd /lib/modules
    for i in *; do
        [[ -f $i/modules.dep ]] || [[ -f $i/modules.dep.bin ]] || continue
        dracut --kver="$i" "${dracut_args[@]}"
        ((ret+=$?))
    done
    exit $ret
fi

if ! [[ $kernel ]]; then
    kernel=$(uname -r)
fi

if [[ $kernel ]]; then
    if ! [[ -d /lib/modules/$kernel ]] && [[ $no_kernel != yes ]]; then
        printf -- "Kernel version $kernel has no module directory /lib/modules/$kernel\n" >&2
    fi
fi

if ! [[ $outfile ]]; then
    [[ -f /etc/machine-id ]] && read MACHINE_ID < /etc/machine-id

    if [[ $MACHINE_ID ]] && ( [[ -d /boot/${MACHINE_ID} ]] || [[ -L /boot/${MACHINE_ID} ]] ); then
        outfile="/boot/${MACHINE_ID}/$kernel/initrd"
    else
        outfile="/boot/initramfs-$kernel.img"
    fi
fi

for i in /usr/sbin /sbin /usr/bin /bin; do
    rl=$i
    if [ -L "$i" ]; then
        rl=$(readlink -f $i)
    fi
    if [[ "$NPATH" != *:$rl* ]] ; then
        NPATH+=":$rl"
    fi
done
export PATH="${NPATH#:}"
unset LC_MESSAGES
unset LC_CTYPE
export LC_ALL=C
export LANG=C
unset NPATH
unset LD_LIBRARY_PATH
unset LD_PRELOAD
unset GREP_OPTIONS

export DRACUT_LOG_LEVEL=warning
[[ $debug ]] && {
    export DRACUT_LOG_LEVEL=debug
    export PS4='${BASH_SOURCE}@${LINENO}(${FUNCNAME[0]}): ';
    set -x
}

[[ $profile ]] && {
    export PS4='+ $(date "+%s.%N") ${BASH_SOURCE}@${LINENO}: ';
    set -x
    debug=yes
}

[[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut

# if we were not passed a config file, try the default one
if [[ ! -f $conffile ]]; then
    if [[ $allowlocal ]]; then
        conffile="$dracutbasedir/dracut.conf"
    else
        conffile="/etc/dracut.conf"
    fi
fi

if [[ ! -d $confdir ]]; then
    if [[ $allowlocal ]]; then
        confdir="$dracutbasedir/dracut.conf.d"
    else
        confdir="/etc/dracut.conf.d"
    fi
fi

# source our config file
[[ -f $conffile ]] && . "$conffile"

# source our config dir
for f in $(dropindirs_sort ".conf" "$confdir" "$dracutbasedir/dracut.conf.d"); do
    [[ -e $f ]] && . "$f"
done

# these optins add to the stuff in the config file
if (( ${#add_dracutmodules_l[@]} )); then
    while pop add_dracutmodules_l val; do
        add_dracutmodules+=" $val "
    done
fi

if (( ${#force_add_dracutmodules_l[@]} )); then
    while pop force_add_dracutmodules_l val; do
        force_add_dracutmodules+=" $val "
    done
fi

if (( ${#fscks_l[@]} )); then
    while pop fscks_l val; do
        fscks+=" $val "
    done
fi

if (( ${#add_fstab_l[@]} )); then
    while pop add_fstab_l val; do
        add_fstab+=" $val "
    done
fi

if (( ${#fstab_lines_l[@]} )); then
    while pop fstab_lines_l val; do
        push fstab_lines $val
    done
fi

if (( ${#install_items_l[@]} )); then
    while pop install_items_l val; do
        install_items+=" $val "
    done
fi

if (( ${#install_optional_items_l[@]} )); then
    while pop install_optional_items_l val; do
        install_optional_items+=" $val "
    done
fi

# these options override the stuff in the config file
if (( ${#dracutmodules_l[@]} )); then
    dracutmodules=''
    while pop dracutmodules_l val; do
        dracutmodules+="$val "
    done
fi

if (( ${#omit_dracutmodules_l[@]} )); then
    omit_dracutmodules=''
    while pop omit_dracutmodules_l val; do
        omit_dracutmodules+="$val "
    done
fi

if (( ${#filesystems_l[@]} )); then
    filesystems=''
    while pop filesystems_l val; do
        filesystems+="$val "
    done
fi

if (( ${#fw_dir_l[@]} )); then
    fw_dir=''
    while pop fw_dir_l val; do
        fw_dir+="$val "
    done
fi

if (( ${#libdirs_l[@]} )); then
    libdirs=''
    while pop libdirs_l val; do
        libdirs+="$val "
    done
fi

[[ $stdloglvl_l ]] && stdloglvl=$stdloglvl_l
[[ ! $stdloglvl ]] && stdloglvl=4
stdloglvl=$((stdloglvl + verbosity_mod_l))
((stdloglvl > 6)) && stdloglvl=6
((stdloglvl < 0)) && stdloglvl=0

[[ $drivers_dir_l ]] && drivers_dir=$drivers_dir_l
[[ $do_strip_l ]] && do_strip=$do_strip_l
[[ $do_strip ]] || do_strip=yes
[[ $do_prelink_l ]] && do_prelink=$do_prelink_l
[[ $do_prelink ]] || do_prelink=yes
[[ $do_hardlink_l ]] && do_hardlink=$do_hardlink_l
[[ $do_hardlink ]] || do_hardlink=yes
[[ $prefix_l ]] && prefix=$prefix_l
[[ $prefix = "/" ]] && unset prefix
[[ $hostonly_l ]] && hostonly=$hostonly_l
[[ $hostonly_cmdline_l ]] && hostonly_cmdline=$hostonly_cmdline_l
[[ $hostonly_mode_l ]] && hostonly_mode=$hostonly_mode_l
[[ $i18n_install_all_l ]] && i18n_install_all=$i18n_install_all_l
[[ $persistent_policy_l ]] && persistent_policy=$persistent_policy_l
[[ $use_fstab_l ]] && use_fstab=$use_fstab_l
[[ $mdadmconf_l ]] && mdadmconf=$mdadmconf_l
[[ $lvmconf_l ]] && lvmconf=$lvmconf_l
[[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
[[ $fw_dir ]] || fw_dir="/lib/firmware/updates /lib/firmware /lib/firmware/$kernel"
[[ $tmpdir_l ]] && tmpdir="$tmpdir_l"
[[ $tmpdir ]] || tmpdir=/var/tmp
[[ $INITRD_COMPRESS ]] && compress=$INITRD_COMPRESS
[[ $compress_l ]] && compress=$compress_l
[[ $show_modules_l ]] && show_modules=$show_modules_l
[[ $nofscks_l ]] && nofscks="yes"
[[ $ro_mnt_l ]] && ro_mnt="yes"
[[ $early_microcode_l ]] && early_microcode=$early_microcode_l
[[ $early_microcode ]] || early_microcode=no
[[ $logfile_l ]] && logfile="$logfile_l"
# eliminate IFS hackery when messing with fw_dir
fw_dir=${fw_dir//:/ }

# handle compression options.
[[ $compress ]] || compress="gzip"
case $compress in
    bzip2) compress="bzip2 -9";;
    lzma)  compress="lzma -9 -T0";;
    xz)    compress="xz --check=crc32 --lzma2=dict=1MiB -T0";;
    gzip)  compress="gzip -9"; command -v pigz > /dev/null 2>&1 && compress="pigz -9";;
    lzo)   compress="lzop -9";;
    lz4)   compress="lz4 -l -9";;
esac
if [[ $_no_compress_l = "cat" ]]; then
    compress="cat"
fi

[[ $hostonly = yes ]] && hostonly="-h"
[[ $hostonly != "-h" ]] && unset hostonly

case $hostonly_mode in
    '')
        [[ $hostonly ]] && hostonly_mode="sloppy" ;;
    sloppy|strict)
        if [[ ! $hostonly ]]; then
            unset hostonly_mode
        fi
        ;;
    *)
        printf "%s\n" "dracut: Invalid hostonly mode '$hostonly_mode'." >&2
        exit 1
esac



readonly TMPDIR="$tmpdir"
readonly DRACUT_TMPDIR="$(mktemp -p "$TMPDIR/" -d -t dracut.XXXXXX)"
[ -d "$DRACUT_TMPDIR" ] || {
    printf "%s\n" "dracut: mktemp -p '$TMPDIR/' -d -t dracut.XXXXXX failed." >&2
    exit 1
}

# clean up after ourselves no matter how we die.
trap '
    ret=$?;
    [[ $keep ]] && echo "Not removing $DRACUT_TMPDIR." >&2 || { [[ $DRACUT_TMPDIR ]] && rm -rf -- "$DRACUT_TMPDIR"; };
    exit $ret;
    ' EXIT

# clean up after ourselves no matter how we die.
trap 'exit 1;' SIGINT

readonly initdir="${DRACUT_TMPDIR}/initramfs"
mkdir "$initdir"

export DRACUT_KERNEL_LAZY="1"
export DRACUT_RESOLVE_LAZY="1"

if [[ $print_cmdline ]]; then
    stdloglvl=0
    sysloglvl=0
    fileloglvl=0
    kmsgloglvl=0
fi

if [[ -f $dracutbasedir/dracut-version.sh ]]; then
    . $dracutbasedir/dracut-version.sh
fi

if [[ -f $dracutbasedir/dracut-init.sh ]]; then
    . $dracutbasedir/dracut-init.sh
else
    printf "%s\n" "dracut: Cannot find $dracutbasedir/dracut-init.sh." >&2
    printf "%s\n" "dracut: Are you running from a git checkout?" >&2
    printf "%s\n" "dracut: Try passing -l as an argument to $0" >&2
    exit 1
fi

if ! [[ $print_cmdline ]]; then
    inst /bin/sh
    if ! $DRACUT_INSTALL ${initdir:+-D "$initdir"} -R "$initdir/bin/sh" &>/dev/null; then
        unset DRACUT_RESOLVE_LAZY
        export DRACUT_RESOLVE_DEPS=1
    fi
    rm -fr -- ${initdir}/*
fi

# Verify bash version, current minimum is 3.1
if (( BASH_VERSINFO[0] < 4 )); then
    dfatal 'You need at least Bash 4 to use dracut, sorry.'
    exit 1
fi

dracutfunctions=$dracutbasedir/dracut-functions.sh
export dracutfunctions



case "$(arch)" in
    i686|x86_64)
        ;;
    *)
        if [[ $early_microcode = yes ]]; then
            early_microcode=no
            dinfo "Disabling early microcode for $(arch)"
        fi
        ;;
esac

if [[ $early_microcode = yes ]] || ( [[ $acpi_override = yes ]] && [[ -d $acpi_table_dir ]] ); then
    readonly early_cpio_dir="${DRACUT_TMPDIR}/earlycpio"
    mkdir "$early_cpio_dir"
fi

if (( ${#drivers_l[@]} )); then
    drivers=''
    while pop drivers_l val; do
        drivers+="$val "
    done
fi
drivers=${drivers/-/_}

if (( ${#add_drivers_l[@]} )); then
    while pop add_drivers_l val; do
        add_drivers+=" $val "
    done
fi
add_drivers=${add_drivers/-/_}

if (( ${#force_drivers_l[@]} )); then
    while pop force_drivers_l val; do
        force_drivers+=" $val "
    done
fi
force_drivers=${force_drivers/-/_}

if (( ${#omit_drivers_l[@]} )); then
    while pop omit_drivers_l val; do
        omit_drivers+=" $val "
    done
fi
omit_drivers=${omit_drivers/-/_}

if (( ${#kernel_cmdline_l[@]} )); then
    while pop kernel_cmdline_l val; do
        kernel_cmdline+=" $val "
    done
fi

omit_drivers_corrected=""
for d in $omit_drivers; do
    [[ " $drivers $add_drivers " == *\ $d\ * ]] && continue
    [[ " $drivers $force_drivers " == *\ $d\ * ]] && continue
    omit_drivers_corrected+="$d|"
done
omit_drivers="${omit_drivers_corrected%|}"
unset omit_drivers_corrected

# prepare args for logging
for ((i=0; i < ${#dracut_args[@]}; i++)); do
    [[ "${dracut_args[$i]}" == *\ * ]] && \
        dracut_args[$i]="\"${dracut_args[$i]}\""
        #" keep vim happy
done

dinfo "Executing: $0 ${dracut_args[@]}"

[[ $do_list = yes ]] && {
    for mod in $dracutbasedir/modules.d/*; do
        [[ -d $mod ]] || continue;
        [[ -e $mod/install || -e $mod/installkernel || \
            -e $mod/module-setup.sh ]] || continue
        printf "%s\n" "${mod##*/??}"
    done
    exit 0
}

# This is kinda legacy -- eventually it should go away.
case $dracutmodules in
    ""|auto) dracutmodules="all" ;;
esac

abs_outfile=$(readlink -f "$outfile") && outfile="$abs_outfile"

if [[ -d $srcmods ]]; then
    if ! [[ -f $srcmods/modules.dep ]]; then
        if [[ -n "$(find "$srcmods" -name '*.ko*')" ]]; then
            dfatal "$srcmods/modules.dep is missing. Did you run depmod?"
            exit 1
        else
            dwarn "$srcmods/modules.dep is missing. Did you run depmod?"
        fi
    fi
fi

if [[ ! $print_cmdline ]]; then
    if [[ -f $outfile && ! $force ]]; then
        dfatal "Will not override existing initramfs ($outfile) without --force"
        exit 1
    fi

    outdir=${outfile%/*}
    [[ $outdir ]] || outdir="/"

    if [[ ! -d "$outdir" ]]; then
        dfatal "Can't write to $outdir: Directory $outdir does not exist or is not accessible."
        exit 1
    elif [[ ! -w "$outdir" ]]; then
        dfatal "No permission to write to $outdir."
        exit 1
    elif [[ -f "$outfile" && ! -w "$outfile" ]]; then
        dfatal "No permission to write $outfile."
        exit 1
    fi
fi

# Need to be able to have non-root users read stuff (rpcbind etc)
chmod 755 "$initdir"

if [[ $hostonly ]]; then
    for i in /sys /proc /run /dev; do
        if ! findmnt --target "$i" &>/dev/null; then
            dwarning "Turning off host-only mode: '$i' is not mounted!"
            unset hostonly
        fi
    done
fi

declare -A host_fs_types

for line in "${fstab_lines[@]}"; do
    set -- $line
    #dev mp fs fsopts
    push host_devs "$1"
    host_fs_types["$1"]="$3"
done

for f in $add_fstab; do
    [[ -e $f ]] || continue
    while read dev rest; do
        push host_devs "$dev"
    done < "$f"
done

for dev in $add_device; do
    push host_devs "$dev"
done

if (( ${#add_device_l[@]} )); then
    while pop add_device_l val; do
        add_device+=" $val "
        push host_devs "$val"
    done
fi

if [[ $hostonly ]] && [[ "$hostonly_default_device" != "no" ]]; then
    # in hostonly mode, determine all devices, which have to be accessed
    # and examine them for filesystem types

    for mp in \
        "/" \
        "/etc" \
        "/bin" \
        "/sbin" \
        "/lib" \
        "/lib64" \
        "/usr" \
        "/usr/bin" \
        "/usr/sbin" \
        "/usr/lib" \
        "/usr/lib64" \
        "/boot" \
        "/boot/efi" \
        ;
    do
        mp=$(readlink -f "$mp")
        mountpoint "$mp" >/dev/null 2>&1 || continue
        _dev=$(find_block_device "$mp")
        _bdev=$(readlink -f "/dev/block/$_dev")
        [[ -b $_bdev ]] && _dev=$_bdev
        push host_devs $_dev
        [[ "$mp" == "/" ]] && root_dev="$_dev"
        push host_devs "$_dev"
    done

    if [[ -f /proc/swaps ]] && [[ -f /etc/fstab ]]; then
        while read dev type rest; do
            [[ -b $dev ]] || continue
            [[ "$type" == "partition" ]] || continue

            while read _d _m _t _o _r; do
                [[ "$_d" == \#* ]] && continue
                [[ $_d ]] || continue
                [[ $_t != "swap" ]] && continue
                [[ $_m != "swap" ]] && [[ $_m != "none" ]] && continue
                [[ "$_o" == *noauto* ]] && continue
                _d=$(expand_persistent_dev "$_d")
                [[ "$_d" -ef "$dev" ]] || continue

                if [[ -f /etc/crypttab ]]; then
                    while read _mapper _a _p _o || [ -n "$_mapper" ]; do
                        [[ $_mapper = \#* ]] && continue
                        [[ "$_d" -ef /dev/mapper/"$_mapper" ]] || continue
                        [[ "$_o" ]] || _o="$_p"
                        # skip entries with password files
                        [[ "$_p" == /* ]] && [[ -f $_p ]] && continue 2
                        # skip mkswap swap
                        [[ $_o == *swap* ]] && continue 2
                    done < /etc/crypttab
                fi

                _dev="$(readlink -f "$dev")"
                push host_devs "$_dev"
                push swap_devs "$_dev"
                break
            done < /etc/fstab
        done < /proc/swaps
    fi

    # collect all "x-initrd.mount" entries from /etc/fstab
    if [[ -f /etc/fstab ]]; then
        while read _d _m _t _o _r || [ -n "$_d" ]; do
            [[ "$_d" == \#* ]] && continue
            [[ $_d ]] || continue
            [[ "$_o" != *x-initrd.mount* ]] && continue
            _dev=$(expand_persistent_dev "$_d")
            _dev="$(readlink -f "$_dev")"
            [[ -b $_dev ]] && push host_devs "$_dev"
        done < /etc/fstab
    fi
fi


if [[ $hostonly ]]; then
    # record all host modaliases
    declare -A host_modalias
    find  /sys/devices/ -name uevent -print > "$initdir/.modalias"
    while read m; do
        while read line; do
            [[ "$line" != MODALIAS\=* ]] && continue
            modalias="${line##MODALIAS=}" && [[ $modalias ]] && host_modalias["$modalias"]=1
            break
        done < "$m"
    done < "$initdir/.modalias"

    rm -f -- "$initdir/.modalias"

    while read _k _s _v; do
        [ "$_k" != "name" -a "$_k" != "driver" ] && continue
        host_modalias["$_v"]=1
    done </proc/crypto

    # check /proc/modules
    declare -A host_modules
    declare new_module_found=1
    declare tmpmodules=$(mktemp --tmpdir="$TMPDIR/" -t proc_modules.XXXXXX)
    while [[ $new_module_found ]]; do
        new_module_found=
        sleep 0.1
        #reading from procfs can be broken, so copy the file elsewhere
        cp -f /proc/modules "$tmpmodules"
        while read m rest; do
            [ -z "$m" ] && continue
            [[ ${host_modules["$m"]} ]] && continue
            host_modules["$m"]=1
            new_module_found=1
        done < "$tmpmodules"
    done
    rm "$tmpmodules"
    unset new_module_found
    unset tmpmodules
fi

unset m
unset rest

_get_fs_type() {
    [[ $1 ]] || return
    if [[ -b /dev/block/$1 ]]; then
        ID_FS_TYPE=$(get_fs_env "/dev/block/$1") && host_fs_types["$(readlink -f "/dev/block/$1")"]="$ID_FS_TYPE"
        return 1
    fi
    if [[ -b $1 ]]; then
        ID_FS_TYPE=$(get_fs_env "$1") && host_fs_types["$(readlink -f "$1")"]="$ID_FS_TYPE"
        return 1
    fi
    if fstype=$(find_dev_fstype "$1"); then
        host_fs_types["$1"]="$fstype"
        return 1
    fi
    return 1
}

for dev in "${host_devs[@]}"; do
    _get_fs_type "$dev"
    check_block_and_slaves_all _get_fs_type "$(get_maj_min "$dev")"
done

for dev in "${!host_fs_types[@]}"; do
    [[ ${host_fs_types[$dev]} = "reiserfs" ]] || [[ ${host_fs_types[$dev]} = "xfs" ]] || continue
    rootopts=$(find_dev_fsopts "$dev")
    if [[ ${host_fs_types[$dev]} = "reiserfs" ]]; then
        journaldev=$(fs_get_option $rootopts "jdev")
    elif [[ ${host_fs_types[$dev]} = "xfs" ]]; then
        journaldev=$(fs_get_option $rootopts "logdev")
    fi
    if [[ $journaldev ]]; then
        dev="$(readlink -f "$dev")"
        push host_devs "$dev"
        _get_fs_type "$dev"
        check_block_and_slaves_all _get_fs_type "$(get_maj_min "$dev")"
    fi
done

# also put the additional filesystems in host_fs_types
# so that the according modules are installed.
for fs in $filesystems; do
    host_fs_types[$fs]="$fs"
done

[[ -d $udevdir ]] \
    || udevdir="$(pkg-config udev --variable=udevdir 2>/dev/null)"
if ! [[ -d "$udevdir" ]]; then
    [[ -d /lib/udev ]] && udevdir=/lib/udev
    [[ -d /usr/lib/udev ]] && udevdir=/usr/lib/udev
fi

[[ -d $systemdutildir ]] \
    || systemdutildir=$(pkg-config systemd --variable=systemdutildir 2>/dev/null)

if ! [[ -d "$systemdutildir" ]]; then
    [[ -d /lib/systemd ]] && systemdutildir=/lib/systemd
    [[ -d /usr/lib/systemd ]] && systemdutildir=/usr/lib/systemd
fi

[[ -d $systemdsystemunitdir ]] \
    || systemdsystemunitdir=$(pkg-config systemd --variable=systemdsystemunitdir 2>/dev/null)

[[ -d "$systemdsystemunitdir" ]] || systemdsystemunitdir=${systemdutildir}/system

[[ -d $systemdsystemconfdir ]] \
    || systemdsystemconfdir=$(pkg-config systemd --variable=systemdsystemconfdir 2>/dev/null)

[[ -d "$systemdsystemconfdir" ]] || systemdsystemconfdir=/etc/systemd/system

[[ -d $tmpfilesdir ]] \
    || tmpfilesdir=$(pkg-config systemd --variable=tmpfilesdir 2>/dev/null)

if ! [[ -d "$tmpfilesdir" ]]; then
    [[ -f /lib/tmpfiles.d ]] && tmpfilesdir=/lib/tmpfiles.d
    [[ -f /usr/lib/tmpfiles.d ]] && tmpfilesdir=/usr/lib/tmpfiles.d
fi

export initdir dracutbasedir \
    dracutmodules force_add_dracutmodules add_dracutmodules omit_dracutmodules \
    mods_to_load \
    fw_dir drivers_dir debug no_kernel kernel_only \
    omit_drivers mdadmconf lvmconf root_dev \
    use_fstab fstab_lines libdirs fscks nofscks ro_mnt \
    stdloglvl sysloglvl fileloglvl kmsgloglvl logfile \
    debug host_fs_types host_devs swap_devs sshkey add_fstab \
    DRACUT_VERSION udevdir prefix filesystems drivers \
    systemdutildir systemdsystemunitdir systemdsystemconfdir \
    host_modalias host_modules hostonly_cmdline loginstall \
    tmpfilesdir

mods_to_load=""
# check all our modules to see if they should be sourced.
# This builds a list of modules that we will install next.
for_each_module_dir check_module
for_each_module_dir check_mount

dracut_module_included "fips" && export DRACUT_FIPS_MODE=1

if [[ $print_cmdline ]]; then
    modules_loaded=" "
    # source our modules.
    for moddir in "$dracutbasedir/modules.d"/[0-9][0-9]*; do
        _d_mod=${moddir##*/}; _d_mod=${_d_mod#[0-9][0-9]}
        module_cmdline "$_d_mod"
    done
    unset moddir
    printf "\n"
    exit 0
fi

# Create some directory structure first
[[ $prefix ]] && mkdir -m 0755 -p "${initdir}${prefix}"

[[ -h /lib ]] || mkdir -m 0755 -p "${initdir}${prefix}/lib"
[[ $prefix ]] && ln -sfn "${prefix#/}/lib" "$initdir/lib"

if [[ $prefix ]]; then
    for d in bin etc lib sbin tmp usr var $libdirs; do
        [[ "$d" == */* ]] && continue
        ln -sfn "${prefix#/}/${d#/}" "$initdir/$d"
    done
fi

if [[ $kernel_only != yes ]]; then
    for d in usr/bin usr/sbin bin etc lib sbin tmp usr var $libdirs; do
        [[ -e "${initdir}${prefix}/$d" ]] && continue
        if [ -L "/$d" ]; then
            inst_symlink "/$d" "${prefix}/$d"
        else
            mkdir -m 0755 -p "${initdir}${prefix}/$d"
        fi
    done

    for d in dev proc sys sysroot root run; do
        if [ -L "/$d" ]; then
            inst_symlink "/$d"
        else
            mkdir -m 0755 -p "$initdir/$d"
        fi
    done

    ln -sfn ../run "$initdir/var/run"
    ln -sfn ../run/lock "$initdir/var/lock"
else
    for d in lib "$libdir"; do
        [[ -e "${initdir}${prefix}/$d" ]] && continue
        if [ -h "/$d" ]; then
            inst "/$d" "${prefix}/$d"
        else
            mkdir -m 0755 -p "${initdir}${prefix}/$d"
        fi
    done
fi

if [[ $kernel_only != yes ]]; then
    mkdir -p "${initdir}/etc/cmdline.d"
    for _d in $hookdirs; do
        mkdir -m 0755 -p ${initdir}/lib/dracut/hooks/$_d
    done
    if [[ "$UID" = "0" ]]; then
        [ -c ${initdir}/dev/null ] || mknod ${initdir}/dev/null c 1 3
        [ -c ${initdir}/dev/kmsg ] || mknod ${initdir}/dev/kmsg c 1 11
        [ -c ${initdir}/dev/console ] || mknod ${initdir}/dev/console c 5 1
    fi
fi

_isize=0 #initramfs size
modules_loaded=" "
# source our modules.
for moddir in "$dracutbasedir/modules.d"/[0-9][0-9]*; do
    _d_mod=${moddir##*/}; _d_mod=${_d_mod#[0-9][0-9]}
    if [[ "$mods_to_load" == *\ $_d_mod\ * ]]; then
        if [[ $show_modules = yes ]]; then
            printf "%s\n" "$_d_mod"
        else
            dinfo "*** Including module: $_d_mod ***"
        fi
        if [[ $kernel_only == yes ]]; then
            module_installkernel "$_d_mod" || {
                dfatal "installkernel failed in module $_d_mod"
                exit 1
            }
        else
            module_install "$_d_mod"
            if [[ $no_kernel != yes ]]; then
                module_installkernel "$_d_mod" || {
                    dfatal "installkernel failed in module $_d_mod"
                    exit 1
                }
            fi
        fi
        mods_to_load=${mods_to_load// $_d_mod /}
        modules_loaded+="$_d_mod "

        #print the module install size
        if [ -n "$printsize" ]; then
            _isize_new=$(du -sk ${initdir}|cut -f1)
            _isize_delta=$((_isize_new - _isize))
            printf "%s\n" "$_d_mod install size: ${_isize_delta}k"
            _isize=$_isize_new
        fi
    fi
done
unset moddir

for i in $modules_loaded; do
    mkdir -p $initdir/lib/dracut
    printf "%s\n" "$i" >> $initdir/lib/dracut/modules.txt
done

dinfo "*** Including modules done ***"

## final stuff that has to happen
if [[ $no_kernel != yes ]]; then
    if [[ $hostonly ]]; then
        echo "$(get_loaded_kernel_modules)" > $initdir/lib/dracut/loaded-kernel-modules.txt
    fi

    if [[ $drivers ]]; then
        hostonly='' instmods $drivers
    fi

    if [[ $add_drivers ]]; then
        hostonly='' instmods -c $add_drivers
    fi
    if [[ $force_drivers ]]; then
        hostonly='' instmods -c $force_drivers
        rm -f $initdir/etc/cmdline.d/20-force_driver.conf
        for mod in $force_drivers; do
            echo "rd.driver.pre=$mod" >>$initdir/etc/cmdline.d/20-force_drivers.conf
        done
    fi
    if [[ $filesystems ]]; then
        hostonly='' instmods -c $filesystems
    fi

    dinfo "*** Installing kernel module dependencies and firmware ***"
    dracut_kernel_post
    dinfo "*** Installing kernel module dependencies and firmware done ***"

    if [[ $noimageifnotneeded == yes ]] && [[ $hostonly ]]; then
        if [[ ! -f "$initdir/lib/dracut/need-initqueue" ]] && \
            [[ -f ${initdir}/lib/modules/$kernel/modules.dep && ! -s ${initdir}/lib/modules/$kernel/modules.dep ]]; then
            for i in ${initdir}/etc/cmdline.d/*.conf; do
                # We need no initramfs image and do not generate one.
                [[ $i == "${initdir}/etc/cmdline.d/*.conf" ]] && exit 0
            done
        fi
    fi
fi

if [[ $kernel_only != yes ]]; then
    (( ${#install_items[@]} > 0 )) && inst_multiple ${install_items[@]}
    (( ${#install_optional_items[@]} > 0 )) && inst_multiple -o ${install_optional_items[@]}

    [[ $kernel_cmdline ]] && printf "%s\n" "$kernel_cmdline" >> "${initdir}/etc/cmdline.d/01-default.conf"

    while pop fstab_lines line; do
        line=($line)
        [ -z "${line[3]}" ] && line[3]="defaults"
        [ -z "${line[4]}" ] && line[4]="0"
        [ -z "${line[5]}" ] && line[5]="2"
        strstr "${line[2]}" "nfs" && line[5]="0"
        echo "${line[@]}" >> "${initdir}/etc/fstab"
    done

    for f in $add_fstab; do
        cat "$f" >> "${initdir}/etc/fstab"
    done

    if [ -d ${initdir}/$systemdutildir ]; then
        mkdir -p ${initdir}/etc/conf.d
        {
            printf "%s\n" "systemdutildir=\"$systemdutildir\""
            printf "%s\n" "systemdsystemunitdir=\"$systemdsystemunitdir\""
            printf "%s\n" "systemdsystemconfdir=\"$systemdsystemconfdir\""
        } > ${initdir}/etc/conf.d/systemd.conf
    fi

    if [[ $DRACUT_RESOLVE_LAZY ]] && [[ $DRACUT_INSTALL ]]; then
        dinfo "*** Resolving executable dependencies ***"
        find "$initdir" -type f \
            '(' -perm -0100 -or -perm -0010 -or -perm -0001 ')' \
            -not -path '*.ko' -print0 \
        | xargs -r -0 $DRACUT_INSTALL ${initdir:+-D "$initdir"} -R ${DRACUT_FIPS_MODE:+-H} --
        dinfo "*** Resolving executable dependencies done***"
    fi
fi

while pop include_src src && pop include_target target; do
    if [[ $src && $target ]]; then
        if [[ -f $src ]]; then
            inst $src $target
        else
            ddebug "Including directory: $src"
            destdir="${initdir}/${target}"
            mkdir -p "$destdir"
            # check for preexisting symlinks, so we can cope with the
            # symlinks to $prefix
            # Objectname is a file or a directory
            for objectname in "$src"/*; do
                [[ -e "$objectname" || -h "$objectname" ]] || continue
                if [[ -d "$objectname" ]]; then
                    # objectname is a directory, let's compute the final directory name
                    object_destdir=${destdir}/${objectname#$src/}
                    if ! [[ -e "$object_destdir" ]]; then
                        mkdir -m 0755 -p "$object_destdir"
                        chmod --reference="$objectname" "$object_destdir"
                    fi
                    cp --reflink=auto --sparse=auto -fa -t "$object_destdir" "$objectname"/*
                else
                    cp --reflink=auto --sparse=auto -fa -t "$destdir" "$objectname"
                fi
            done
        fi
    fi
done

if [[ $kernel_only != yes ]]; then
    # make sure that library links are correct and up to date
    for f in /etc/ld.so.conf /etc/ld.so.conf.d/*; do
        [[ -f $f ]] && inst_simple "$f"
    done
    if ! ldconfig -r "$initdir"; then
        if [[ $UID = 0 ]]; then
            derror "ldconfig exited ungracefully"
        else
            derror "ldconfig might need uid=0 (root) for chroot()"
        fi
    fi
fi

PRELINK_BIN="$(command -v prelink)"
if [[ $UID = 0 ]] && [[ $PRELINK_BIN ]]; then
    if [[ $DRACUT_FIPS_MODE ]]; then
        dinfo "*** Installing prelink files ***"
        inst_multiple -o prelink /etc/prelink.conf /etc/prelink.conf.d/*.conf /etc/prelink.cache
    elif [[ $do_prelink == yes ]]; then
        dinfo "*** Pre-linking files ***"
        inst_multiple -o prelink /etc/prelink.conf /etc/prelink.conf.d/*.conf
        chroot "$initdir" "$PRELINK_BIN" -a
        rm -f -- "$initdir/$PRELINK_BIN"
        rm -fr -- "$initdir"/etc/prelink.*
        dinfo "*** Pre-linking files done ***"
    fi
fi

if [[ $do_hardlink = yes ]] && command -v hardlink >/dev/null; then
    dinfo "*** Hardlinking files ***"
    hardlink "$initdir" 2>&1
    dinfo "*** Hardlinking files done ***"
fi

# strip binaries
if [[ $do_strip = yes ]] ; then
    for p in strip xargs find; do
        if ! type -P $p >/dev/null; then
            dinfo "Could not find '$p'. Not stripping the initramfs."
            do_strip=no
        fi
    done
fi

if [[ $do_strip = yes ]] && ! [[ $DRACUT_FIPS_MODE ]]; then
    dinfo "*** Stripping files ***"
    find "$initdir" -type f \
        -executable -not -path '*/lib/modules/*.ko' -print0 \
        | xargs -r -0 strip -g 2>/dev/null

    # strip kernel modules, but do not touch signed modules
    find "$initdir" -type f -path '*/lib/modules/*.ko' -print0 \
        | while read -r -d $'\0' f; do
        SIG=$(tail -c 28 "$f")
        [[ $SIG == '~Module signature appended~' ]] || { printf "%s\000" "$f"; }
    done | xargs -r -0 strip -g

    dinfo "*** Stripping files done ***"
fi

if [[ $early_microcode = yes ]]; then
    dinfo "*** Generating early-microcode cpio image contents ***"
    ucode_dir=(amd-ucode intel-ucode)
    ucode_dest=(AuthenticAMD.bin GenuineIntel.bin)
    _dest_dir="$early_cpio_dir/d/kernel/x86/microcode"
    _dest_idx="0 1"
    mkdir -p $_dest_dir
    if [[ $hostonly ]]; then
        [[ $(get_cpu_vendor) == "AMD" ]] && _dest_idx="0"
        [[ $(get_cpu_vendor) == "Intel" ]] && _dest_idx="1"
    fi
    for idx in $_dest_idx; do
        _fw=${ucode_dir[$idx]}
        for _fwdir in $fw_dir; do
            if [[ -d $_fwdir && -d $_fwdir/$_fw ]]; then
                _src="*"
                dinfo "*** Constructing ${ucode_dest[$idx]} ****"
                if [[ $hostonly ]]; then
                    _src=$(get_ucode_file)
                    [[ $_src ]] || break
                    [[ -r $_fwdir/$_fw/$_src ]] || break
                fi

                for i in $_fwdir/$_fw/$_src; do
                    [ -e "$i" ] && break
                    break 2
                done
                for i in $_fwdir/$_fw/$_src; do
                    [[ -e "$i" ]] || continue
                    # skip gpg files
                    str_ends "$i" ".asc" && continue
                    cat "$i" >> $_dest_dir/${ucode_dest[$idx]}
                done
                create_early_cpio="yes"
            fi
        done
    done
    if ! [[ $create_early_cpio = yes ]]; then
        dinfo "*** No early-microcode cpio image needed ***"
    fi
fi

if [[ $acpi_override = yes ]] && [[ -d $acpi_table_dir ]]; then
    dinfo "*** Packaging ACPI tables to override BIOS provided ones ***"
    _dest_dir="$early_cpio_dir/d/kernel/firmware/acpi"
    mkdir -p $_dest_dir
    for table in $acpi_table_dir/*.aml; do
        dinfo "   Adding ACPI table: $table"
        cp $table $_dest_dir
        create_early_cpio="yes"
    done
fi

dinfo "*** Store current command line parameters ***"
if ! ( echo $PARMS_TO_STORE > $initdir/lib/dracut/build-parameter.txt ); then
    dfatal "Could not store the current command line parameters"
    exit 1
fi

rm -f -- "$outfile"
dinfo "*** Creating image file ***"

[[ "$UID" != 0 ]] && cpio_owner_root="-R 0:0"

if [[ $create_early_cpio = yes ]]; then
    dinfo "*** Creating microcode section ***"
    echo 1 > "$early_cpio_dir/d/early_cpio"
    # The microcode blob is _before_ the initramfs blob, not after
    if ! (
            umask 077
            cd "$early_cpio_dir/d"
            find . -print0 | cpio --null $cpio_owner_root -H newc -o --quiet > "${DRACUT_TMPDIR}/initramfs.img"
        ); then
        dfatal "dracut: creation of $outfile failed"
        exit 1
    else
        dinfo "*** Created microcode section ***"
    fi
fi

if ! (
        umask 077
        cd "$initdir"
        find . -print0 | cpio --null $cpio_owner_root -H newc -o --quiet | \
            $compress >> "${DRACUT_TMPDIR}/initramfs.img";
    ); then
    dfatal "dracut: creation of $outfile failed"
    exit 1
fi

dinfo "*** Creating image file done ***"

if (( maxloglvl >= 5 )) && (( verbosity_mod_l >= 0 )); then
    if [[ $allowlocal ]]; then
	"$dracutbasedir/lsinitrd.sh" "${DRACUT_TMPDIR}/initramfs.img" | ddebug
    else
        lsinitrd "${DRACUT_TMPDIR}/initramfs.img" | ddebug
    fi
fi

if cp --reflink=auto "${DRACUT_TMPDIR}/initramfs.img" "$outfile" |& derror ; then
    dinfo "*** Creating initramfs image file '$outfile' done ***"
else
    rm -f -- "$outfile"
    dfatal "dracut: creation of $outfile failed"
    exit 1
fi


if ! sync "$outfile" 2> /dev/null; then
    dinfo "dracut: sync operartion on newly created initramfs $outfile failed"
    exit 1
fi

exit 0
N4m3
5!z3
L45t M0d!f!3d
0wn3r / Gr0up
P3Rm!55!0n5
0pt!0n5
..
--
December 21 2023 09:06:33
0 / 0
0555
[
40.516 KB
November 16 2020 22:24:58
0 / 0
0755
a2p
105.32 KB
February 02 2021 16:33:17
0 / 0
0755
ab
51.406 KB
May 30 2023 14:01:58
0 / 0
0755
addr2line
28.422 KB
November 01 2021 15:39:15
0 / 0
0755
alias
0.028 KB
November 24 2021 16:33:26
0 / 0
0755
apropos
45.492 KB
October 30 2018 20:26:36
0 / 0
0755
ar
61.219 KB
November 01 2021 15:39:15
0 / 0
0755
arch
32.305 KB
November 16 2020 22:24:58
0 / 0
0755
as
377.359 KB
November 01 2021 15:39:15
0 / 0
0755
aserver
28.211 KB
August 08 2019 12:00:59
0 / 0
0755
aulast
15.484 KB
August 08 2019 12:06:06
0 / 0
0755
aulastlog
11.352 KB
August 08 2019 12:06:06
0 / 0
0755
ausyscall
11.18 KB
August 08 2019 12:06:06
0 / 0
0755
auvirt
31.93 KB
August 08 2019 12:06:06
0 / 0
0755
awk
418.539 KB
June 28 2017 21:52:48
0 / 0
0755
base64
36.484 KB
November 16 2020 22:24:58
0 / 0
0755
basename
28.352 KB
November 16 2020 22:24:58
0 / 0
0755
bash
941.93 KB
November 24 2021 16:33:27
0 / 0
0755
bashbug
6.801 KB
November 24 2021 16:33:21
0 / 0
0755
bashbug-64
6.801 KB
November 24 2021 16:33:21
0 / 0
0755
bc
81.469 KB
June 09 2014 19:51:54
0 / 0
0755
bg
0.025 KB
November 24 2021 16:33:26
0 / 0
0755
bond2team
22.739 KB
December 09 2018 08:57:18
0 / 0
0755
bootctl
68.992 KB
December 07 2023 14:51:48
0 / 0
0755
busctl
403.203 KB
December 07 2023 14:51:48
0 / 0
0755
c++filt
27.922 KB
November 01 2021 15:39:15
0 / 0
0755
c2ph
35.749 KB
February 02 2021 16:32:27
0 / 0
0755
c89
0.219 KB
September 30 2020 02:17:38
0 / 0
0755
c99
0.21 KB
September 30 2020 02:17:38
0 / 0
0755
ca-legacy
1.6 KB
January 13 2022 17:12:22
0 / 0
0755
cal
36.805 KB
February 02 2021 16:31:53
0 / 0
0755
captoinfo
64.258 KB
September 06 2017 22:08:20
0 / 0
0755
cat
52.813 KB
November 16 2020 22:24:58
0 / 0
0755
catchsegv
3.258 KB
June 04 2024 14:43:46
0 / 0
0755
catman
36.75 KB
October 30 2018 20:26:36
0 / 0
0755
cc
750.594 KB
September 30 2020 02:18:23
0 / 0
0755
cd
0.025 KB
November 24 2021 16:33:26
0 / 0
0755
centrino-decode
6.133 KB
June 04 2024 14:55:42
0 / 0
0755
certutil
179.75 KB
October 19 2023 13:17:47
0 / 0
0755
chacl
15.266 KB
April 01 2020 02:16:13
0 / 0
0755
chage
72.156 KB
August 09 2019 02:51:01
0 / 0
4755
chardetect
0.3 KB
August 09 2019 02:04:55
0 / 0
0755
chattr
11.266 KB
September 30 2020 15:58:29
0 / 0
0755
chcon
61.461 KB
November 16 2020 22:24:58
0 / 0
0755
chfn
23.406 KB
February 02 2021 16:31:53
0 / 0
4711
chgrp
61.32 KB
November 16 2020 22:24:58
0 / 0
0755
chmem
40.43 KB
February 02 2021 16:31:53
0 / 0
0755
chmod
57.211 KB
November 16 2020 22:24:58
0 / 0
0755
chown
61.359 KB
November 16 2020 22:24:58
0 / 0
0755
chrt
32.172 KB
February 02 2021 16:31:53
0 / 0
0755
chsh
23.32 KB
February 02 2021 16:31:53
0 / 0
4711
chvt
11.141 KB
November 24 2021 16:34:03
0 / 0
0755
cksum
32.375 KB
November 16 2020 22:24:58
0 / 0
0755
clear
7.023 KB
September 06 2017 22:08:20
0 / 0
0755
cmp
44.141 KB
March 07 2023 14:48:24
0 / 0
0755
cmsutil
110.594 KB
October 19 2023 13:17:47
0 / 0
0755
col
23.883 KB
February 02 2021 16:31:53
0 / 0
0755
colcrt
11.289 KB
February 02 2021 16:31:53
0 / 0
0755
colrm
23.773 KB
February 02 2021 16:31:53
0 / 0
0755
column
27.992 KB
February 02 2021 16:31:53
0 / 0
0755
comm
36.547 KB
November 16 2020 22:24:58
0 / 0
0755
command
0.03 KB
November 24 2021 16:33:26
0 / 0
0755
coredumpctl
154.516 KB
December 07 2023 14:51:48
0 / 0
0755
cp
151.547 KB
November 16 2020 22:24:58
0 / 0
0755
cpio
142.547 KB
October 13 2020 15:47:58
0 / 0
0755
cpp
754.578 KB
September 30 2020 02:18:22
0 / 0
0755
cpupower
66.336 KB
June 04 2024 14:55:43
0 / 0
0755
crlutil
127 KB
October 19 2023 13:17:47
0 / 0
0755
crontab
56.227 KB
May 16 2023 14:28:22
0 / 0
4755
csplit
48.82 KB
November 16 2020 22:24:58
0 / 0
0755
csslint-0.6
19.555 KB
September 30 2020 16:45:45
0 / 0
0755
curl
152.992 KB
December 13 2023 16:08:32
0 / 0
0755
cut
40.609 KB
November 16 2020 22:24:58
0 / 0
0755
cvtsudoers
241.703 KB
January 25 2023 16:36:33
0 / 0
0755
date
60.742 KB
November 16 2020 22:24:58
0 / 0
0755
db_archive
11.227 KB
August 09 2019 00:18:22
0 / 0
0755
db_checkpoint
11.305 KB
August 09 2019 00:18:22
0 / 0
0755
db_deadlock
11.313 KB
August 09 2019 00:18:22
0 / 0
0755
db_dump
15.328 KB
August 09 2019 00:18:22
0 / 0
0755
db_dump185
64.445 KB
August 09 2019 00:18:22
0 / 0
0755
db_hotbackup
15.344 KB
August 09 2019 00:18:22
0 / 0
0755
db_load
27.508 KB
August 09 2019 00:18:22
0 / 0
0755
db_log_verify
15.336 KB
August 09 2019 00:18:22
0 / 0
0755
db_printlog
32.258 KB
August 09 2019 00:18:22
0 / 0
0755
db_recover
11.328 KB
August 09 2019 00:18:22
0 / 0
0755
db_replicate
15.344 KB
August 09 2019 00:18:22
0 / 0
0755
db_stat
15.258 KB
August 09 2019 00:18:22
0 / 0
0755
db_tuner
19.328 KB
August 09 2019 00:18:22
0 / 0
0755
db_upgrade
11.234 KB
August 09 2019 00:18:22
0 / 0
0755
db_verify
11.25 KB
August 09 2019 00:18:22
0 / 0
0755
dbus-binding-tool
94.492 KB
June 10 2014 04:06:04
0 / 0
0755
dbus-cleanup-sockets
11 KB
September 30 2020 15:54:54
0 / 0
0755
dbus-daemon
218 KB
September 30 2020 15:54:54
0 / 0
0755
dbus-monitor
23.125 KB
September 30 2020 15:54:54
0 / 0
0755
dbus-run-session
14.969 KB
September 30 2020 15:54:54
0 / 0
0755
dbus-send
27.07 KB
September 30 2020 15:54:54
0 / 0
0755
dbus-test-tool
23.133 KB
September 30 2020 15:54:54
0 / 0
0755
dbus-update-activation-environment
15.023 KB
September 30 2020 15:54:54
0 / 0
0755
dbus-uuidgen
10.984 KB
September 30 2020 15:54:54
0 / 0
0755
dc
44.328 KB
June 09 2014 19:51:54
0 / 0
0755
dd
73.141 KB
November 16 2020 22:24:58
0 / 0
0755
deallocvt
11.156 KB
November 24 2021 16:34:03
0 / 0
0755
debuginfo-install
7.882 KB
May 12 2020 16:27:40
0 / 0
0755
df
102.555 KB
November 16 2020 22:24:58
0 / 0
0755
dgawk
502.117 KB
June 28 2017 21:52:48
0 / 0
0755
diff
195.461 KB
March 07 2023 14:48:24
0 / 0
0755
diff3
60.648 KB
March 07 2023 14:48:24
0 / 0
0755
dir
114.852 KB
November 16 2020 22:24:58
0 / 0
0755
dircolors
40.438 KB
November 16 2020 22:24:58
0 / 0
0755
dirname
28.313 KB
November 16 2020 22:24:58
0 / 0
0755
dmesg
48.516 KB
February 02 2021 16:31:53
0 / 0
0755
dnsdomainname
15.414 KB
October 18 2019 16:02:04
0 / 0
0755
domainname
15.414 KB
October 18 2019 16:02:04
0 / 0
0755
dracut
55.827 KB
September 30 2020 15:57:57
0 / 0
0755
du
110.336 KB
November 16 2020 22:24:58
0 / 0
0755
dumpkeys
77.508 KB
November 24 2021 16:34:03
0 / 0
0755
dwp
3.03 MB
November 01 2021 15:39:15
0 / 0
0755
echo
32.313 KB
November 16 2020 22:24:58
0 / 0
0755
egrep
0.283 KB
August 03 2017 06:58:17
0 / 0
0755
eject
48.813 KB
February 02 2021 16:31:53
0 / 0
0755
elfedit
32.18 KB
November 01 2021 15:39:15
0 / 0
0755
env
28.328 KB
November 16 2020 22:24:58
0 / 0
0755
envsubst
36.008 KB
April 01 2020 02:43:18
0 / 0
0755
eqn
144.414 KB
June 09 2014 20:17:22
0 / 0
0755
ex
906.445 KB
December 15 2020 16:44:13
0 / 0
0755
expand
32.477 KB
November 16 2020 22:24:58
0 / 0
0755
expr
36.531 KB
November 16 2020 22:24:58
0 / 0
0755
factor
93.289 KB
November 16 2020 22:24:58
0 / 0
0755
fallocate
27.844 KB
February 02 2021 16:31:53
0 / 0
0755
false
28.25 KB
November 16 2020 22:24:58
0 / 0
0755
fc
0.025 KB
November 24 2021 16:33:26
0 / 0
0755
fc-cache
0.129 KB
October 30 2018 15:13:26
0 / 0
0755
fc-cache-64
15.453 KB
October 30 2018 18:34:13
0 / 0
0755
fc-cat
15.398 KB
October 30 2018 18:34:13
0 / 0
0755
fc-conflist
11.195 KB
October 30 2018 18:34:13
0 / 0
0755
fc-list
11.258 KB
October 30 2018 18:34:13
0 / 0
0755
fc-match
11.32 KB
October 30 2018 18:34:13
0 / 0
0755
fc-pattern
11.258 KB
October 30 2018 18:34:13
0 / 0
0755
fc-query
11.227 KB
October 30 2018 18:34:13
0 / 0
0755
fc-scan
11.266 KB
October 30 2018 18:34:13
0 / 0
0755
fc-validate
11.266 KB
October 30 2018 18:34:13
0 / 0
0755
fg
0.025 KB
November 24 2021 16:33:26
0 / 0
0755
fgconsole
11.164 KB
November 24 2021 16:34:03
0 / 0
0755
fgrep
0.283 KB
August 03 2017 06:58:17
0 / 0
0755
file
19.305 KB
September 30 2020 16:08:22
0 / 0
0755
find
194.633 KB
October 30 2018 16:42:55
0 / 0
0755
find-repos-of-install
4.269 KB
May 12 2020 16:27:40
0 / 0
0755
find2perl
23.061 KB
February 02 2021 16:32:27
0 / 0
0755
findmnt
58.375 KB
February 02 2021 16:31:53
0 / 0
0755
fipscheck
15.367 KB
August 02 2017 12:47:49
0 / 0
0755
fipshmac
11.305 KB
August 02 2017 12:47:49
0 / 0
0755
firewall-cmd
113.477 KB
April 28 2021 13:31:12
0 / 0
0755
firewall-offline-cmd
101.179 KB
April 28 2021 13:31:12
0 / 0
0755
flock
23.875 KB
February 02 2021 16:31:53
0 / 0
0755
fmt
36.477 KB
November 16 2020 22:24:58
0 / 0
0755
fold
36.461 KB
November 16 2020 22:24:58
0 / 0
0755
free
19.328 KB
September 30 2020 17:21:37
0 / 0
0755
fribidi
16.094 KB
December 23 2019 15:39:41
0 / 0
0755
gapplication
19.477 KB
June 09 2021 16:12:02
0 / 0
0755
gawk
418.539 KB
June 28 2017 21:52:48
0 / 0
0755
gcc
750.594 KB
September 30 2020 02:18:23
0 / 0
0755
gcc-ar
26.453 KB
September 30 2020 02:18:23
0 / 0
0755
gcc-nm
26.453 KB
September 30 2020 02:18:24
0 / 0
0755
gcc-ranlib
26.453 KB
September 30 2020 02:18:22
0 / 0
0755
gcov
307.453 KB
September 30 2020 02:18:21
0 / 0
0755
gdbus
40.172 KB
June 09 2021 16:12:02
0 / 0
0755
gencat
22.109 KB
June 04 2024 15:05:31
0 / 0
0755
genl-ctrl-list
11.273 KB
August 03 2017 19:48:51
0 / 0
0755
geqn
144.414 KB
June 09 2014 20:17:22
0 / 0
0755
getconf
22.016 KB
June 04 2024 15:05:30
0 / 0
0755
getent
26.391 KB
June 04 2024 15:05:30
0 / 0
0755
getfacl
24.289 KB
April 01 2020 02:16:13
0 / 0
0755
getkeycodes
11.156 KB
November 24 2021 16:34:03
0 / 0
0755
getopt
15.383 KB
February 02 2021 16:31:53
0 / 0
0755
getopts
0.03 KB
November 24 2021 16:33:26
0 / 0
0755
gettext
35.938 KB
April 01 2020 02:43:18
0 / 0
0755
gettext.sh
4.521 KB
April 01 2020 02:41:05
0 / 0
0755
gio
73.414 KB
June 09 2021 16:12:02
0 / 0
0755
gio-querymodules-64
11.313 KB
June 09 2021 16:12:02
0 / 0
0755
glib-compile-schemas
44.375 KB
June 09 2021 16:12:02
0 / 0
0755
gmake
178.469 KB
August 09 2019 00:46:49
0 / 0
0755
gneqn
0.265 KB
June 09 2014 20:17:13
0 / 0
0755
gnroff
3.313 KB
June 09 2014 20:17:15
0 / 0
0755
gpasswd
76.57 KB
August 09 2019 02:51:01
0 / 0
4755
gpg
732.398 KB
July 13 2018 13:05:25
0 / 0
0755
gpg-agent
289.742 KB
July 13 2018 13:05:25
0 / 0
0755
gpg-connect-agent
152.688 KB
July 13 2018 13:05:25
0 / 0
0755
gpg-error
23.18 KB
June 10 2014 08:46:48
0 / 0
0755
gpg-zip
3.229 KB
July 13 2018 13:05:12
0 / 0
0755
gpg2
732.398 KB
July 13 2018 13:05:25
0 / 0
0755
gpgconf
140.313 KB
July 13 2018 13:05:25
0 / 0
0755
gpgparsemail
23.703 KB
July 13 2018 13:05:25
0 / 0
0755
gpgsplit
48.883 KB
July 13 2018 13:05:25
0 / 0
0755
gpgv
345.383 KB
July 13 2018 13:05:25
0 / 0
0755
gpgv2
345.383 KB
July 13 2018 13:05:25
0 / 0
0755
gpic
180.406 KB
June 09 2014 20:17:22
0 / 0
0755
gprof
98.414 KB
November 01 2021 15:39:15
0 / 0
0755
gr2fonttest
23.656 KB
July 21 2017 10:40:25
0 / 0
0755
grep
155.297 KB
August 03 2017 06:58:18
0 / 0
0755
groff
81.625 KB
June 09 2014 20:17:22
0 / 0
0755
grops
140.852 KB
June 09 2014 20:17:22
0 / 0
0755
grotty
98.586 KB
June 09 2014 20:17:22
0 / 0
0755
groups
32.414 KB
November 16 2020 22:24:58
0 / 0
0755
grub2-editenv
396.07 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-file
834.336 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-fstest
1.03 MB
April 30 2024 19:38:58
0 / 0
0755
grub2-glue-efi
258.836 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-kbdcomp
1.629 KB
April 30 2024 19:38:51
0 / 0
0755
grub2-menulst2cfg
241.852 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-mkfont
287.578 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-mkimage
379.211 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-mklayout
264.898 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-mknetdir
429.797 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-mkpasswd-pbkdf2
271.289 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-mkrelpath
258.477 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-mkrescue
1017.852 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-mkstandalone
534.328 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-render-label
839.117 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-script-check
295.414 KB
April 30 2024 19:38:58
0 / 0
0755
grub2-syslinux2cfg
763.703 KB
April 30 2024 19:38:58
0 / 0
0755
gsettings
23.805 KB
June 09 2021 16:12:02
0 / 0
0755
gsoelim
32.586 KB
June 09 2014 20:17:22
0 / 0
0755
gtar
338.023 KB
October 30 2018 20:24:30
0 / 0
0755
gtbl
115.961 KB
June 09 2014 20:17:22
0 / 0
0755
gtroff
512.961 KB
June 09 2014 20:17:22
0 / 0
0755
gunzip
2.2 KB
May 12 2022 14:58:32
0 / 0
0755
gzexe
5.792 KB
May 12 2022 14:58:32
0 / 0
0755
gzip
98.43 KB
May 12 2022 14:58:32
0 / 0
0755
h2ph
27.646 KB
February 02 2021 16:32:27
0 / 0
0755
hdsploader
11.18 KB
November 05 2016 18:34:04
0 / 0
0755
head
40.508 KB
November 16 2020 22:24:58
0 / 0
0755
hexdump
32.016 KB
February 02 2021 16:31:53
0 / 0
0755
hostid
28.32 KB
November 16 2020 22:24:58
0 / 0
0755
hostname
15.414 KB
October 18 2019 16:02:04
0 / 0
0755
hostnamectl
318.07 KB
December 07 2023 14:51:48
0 / 0
0755
htdbm
23.102 KB
May 30 2023 14:01:58
0 / 0
0755
htdigest
15.078 KB
May 30 2023 14:01:58
0 / 0
0755
htpasswd
19.094 KB
May 30 2023 14:01:58
0 / 0
0755
httxt2dbm
10.992 KB
May 30 2023 14:01:58
0 / 0
0755
i386
15.273 KB
February 02 2021 16:31:53
0 / 0
0755
iconv
58.141 KB
June 04 2024 15:05:31
0 / 0
0755
id
36.523 KB
November 16 2020 22:24:58
0 / 0
0755
idiag-socket-details
11.336 KB
August 03 2017 19:48:51
0 / 0
0755
idn
32.453 KB
November 21 2015 17:00:47
0 / 0
0755
igawk
3.113 KB
June 28 2017 21:52:45
0 / 0
0755
info
265.188 KB
April 11 2018 01:03:35
0 / 0
0755
infocmp
56.07 KB
September 06 2017 22:08:20
0 / 0
0755
infokey
21.469 KB
April 11 2018 01:03:35
0 / 0
0755
infotocap
64.258 KB
September 06 2017 22:08:20
0 / 0
0755
install
139.594 KB
November 16 2020 22:24:58
0 / 0
0755
ionice
23.859 KB
February 02 2021 16:31:53
0 / 0
0755
ipcalc
15.055 KB
November 16 2020 16:20:20
0 / 0
0755
ipcmk
24 KB
February 02 2021 16:31:53
0 / 0
0755
ipcrm
27.852 KB
February 02 2021 16:31:53
0 / 0
0755
ipcs
48.367 KB
February 02 2021 16:31:53
0 / 0
0755
iptables-xml
91.516 KB
October 01 2020 16:52:53
0 / 0
0755
isosize
23.828 KB
February 02 2021 16:31:53
0 / 0
0755
jobs
0.027 KB
November 24 2021 16:33:26
0 / 0
0755
join
48.75 KB
November 16 2020 22:24:58
0 / 0
0755
journalctl
537.883 KB
December 07 2023 14:51:48
0 / 0
0755
kbd_mode
11.156 KB
November 24 2021 16:34:03
0 / 0
0755
kbdinfo
11.188 KB
November 24 2021 16:34:03
0 / 0
0755
kbdrate
11.219 KB
November 24 2021 16:34:03
0 / 0
0755
kdumpctl
33.178 KB
June 09 2021 16:09:58
0 / 0
0755
kernel-install
4.698 KB
December 07 2023 14:51:17
0 / 0
0755
kill
32.82 KB
February 02 2021 16:31:53
0 / 0
0755
kmod
143.242 KB
April 01 2020 02:58:15
0 / 0
0755
last
19.109 KB
June 09 2014 23:16:44
0 / 0
0755
lastb
19.109 KB
June 09 2014 23:16:44
0 / 0
0755
lastlog
19.148 KB
August 09 2019 02:51:01
0 / 0
0755
lchfn
15.523 KB
April 12 2018 18:44:23
0 / 0
0755
lchsh
15.492 KB
April 12 2018 18:44:23
0 / 0
0755
ld
982.609 KB
November 01 2021 15:39:15
0 / 0
0755
ld.bfd
982.609 KB
November 01 2021 15:39:15
0 / 0
0755
ld.gold
5.11 MB
November 01 2021 15:39:15
0 / 0
0755
ldd
5.178 KB
June 04 2024 14:43:52
0 / 0
0755
less
154.57 KB
June 11 2024 14:35:22
0 / 0
0755
lessecho
11.133 KB
June 11 2024 14:35:22
0 / 0
0755
lesskey
16.672 KB
June 11 2024 14:35:22
0 / 0
0755
lesspipe.sh
2.237 KB
January 13 2022 18:00:05
0 / 0
0755
lexgrog
85.086 KB
October 30 2018 20:26:36
0 / 0
0755
link
28.305 KB
November 16 2020 22:24:58
0 / 0
0755
linux-boot-prober
5.854 KB
November 06 2016 03:30:02
0 / 0
0755
linux32
15.273 KB
February 02 2021 16:31:53
0 / 0
0755
linux64
15.273 KB
February 02 2021 16:31:53
0 / 0
0755
ln
57.219 KB
November 16 2020 22:24:58
0 / 0
0755
loadkeys
110.484 KB
November 24 2021 16:34:03
0 / 0
0755
loadunimap
23.883 KB
November 24 2021 16:34:03
0 / 0
0755
locale
37.109 KB
June 04 2024 15:05:31
0 / 0
0755
localectl
326.164 KB
December 07 2023 14:51:48
0 / 0
0755
localedef
318.313 KB
June 04 2024 15:05:31
0 / 0
0755
logger
28.617 KB
February 02 2021 16:31:53
0 / 0
0755
login
36.375 KB
February 02 2021 16:31:53
0 / 0
0755
loginctl
489.617 KB
December 07 2023 14:51:48
0 / 0
0755
logname
28.313 KB
November 16 2020 22:24:58
0 / 0
0755
logresolve
11 KB
May 30 2023 14:01:58
0 / 0
0755
look
11.273 KB
February 02 2021 16:31:53
0 / 0
0755
ls
114.852 KB
November 16 2020 22:24:58
0 / 0
0755
lsattr
11.25 KB
September 30 2020 15:58:29
0 / 0
0755
lsblk
79.172 KB
February 02 2021 16:31:53
0 / 0
0755
lscpu
60.75 KB
February 02 2021 16:31:53
0 / 0
0755
lsinitrd
6.26 KB
September 30 2020 15:57:57
0 / 0
0755
lsipc
60.945 KB
February 02 2021 16:31:53
0 / 0
0755
lslocks
41.008 KB
February 02 2021 16:31:53
0 / 0
0755
lslogins
52.883 KB
February 02 2021 16:31:53
0 / 0
0755
lsmem
40.781 KB
February 02 2021 16:31:53
0 / 0
0755
lsns
36.43 KB
February 02 2021 16:31:53
0 / 0
0755
lsscsi
56.477 KB
August 03 2017 02:11:06
0 / 0
0755
lua
15.469 KB
November 06 2016 02:47:35
0 / 0
0755
luac
119.031 KB
November 06 2016 02:47:35
0 / 0
0755
lz4
105.844 KB
September 30 2020 16:55:11
0 / 0
0755
lz4c
105.844 KB
September 30 2020 16:55:11
0 / 0
0755
lz4cat
105.844 KB
September 30 2020 16:55:11
0 / 0
0755
machinectl
533.953 KB
December 07 2023 14:51:48
0 / 0
0755
mailq
242.109 KB
April 01 2020 04:09:09
0 / 0
0755
mailq.postfix
242.109 KB
April 01 2020 04:09:09
0 / 0
0755
make
178.469 KB
August 09 2019 00:46:49
0 / 0
0755
makedb
18.109 KB
June 04 2024 15:05:31
0 / 0
0755
man
100.438 KB
October 30 2018 20:26:36
0 / 0
0755
mandb
122.25 KB
October 30 2018 20:26:36
0 / 0
0755
manpath
32.555 KB
October 30 2018 20:26:36
0 / 0
0755
mapscrn
19.781 KB
November 24 2021 16:34:03
0 / 0
0755
mcookie
15.438 KB
February 02 2021 16:31:53
0 / 0
0755
md5sum
40.531 KB
November 16 2020 22:24:58
0 / 0
0755
mesg
10.977 KB
June 09 2014 23:16:44
0 / 0
0755
mixartloader
15.375 KB
November 05 2016 18:34:04
0 / 0
0755
mkdir
77.898 KB
November 16 2020 22:24:58
0 / 0
0755
mkfifo
61.586 KB
November 16 2020 22:24:58
0 / 0
0755
mkinitrd
2.942 KB
September 30 2020 15:57:57
0 / 0
0755
mknod
65.609 KB
November 16 2020 22:24:58
0 / 0
0755
mktemp
40.656 KB
November 16 2020 22:24:58
0 / 0
0755
modutil
165.781 KB
October 19 2023 13:17:47
0 / 0
0755
more
40.148 KB
February 02 2021 16:31:53
0 / 0
0755
mount
43.227 KB
February 02 2021 16:31:53
0 / 0
4755
mountpoint
15.32 KB
February 02 2021 16:31:53
0 / 0
0755
msgattrib
23.359 KB
April 01 2020 02:43:18
0 / 0
0755
msgcat
23.336 KB
April 01 2020 02:43:18
0 / 0
0755
msgcmp
23.586 KB
April 01 2020 02:43:18
0 / 0
0755
msgcomm
19.313 KB
April 01 2020 02:43:18
0 / 0
0755
msgconv
19.305 KB
April 01 2020 02:43:18
0 / 0
0755
msgen
19.305 KB
April 01 2020 02:43:18
0 / 0
0755
msgexec
15.328 KB
April 01 2020 02:43:18
0 / 0
0755
msgfilter
27.563 KB
April 01 2020 02:43:18
0 / 0
0755
msgfmt
77.055 KB
April 01 2020 02:43:18
0 / 0
0755
msggrep
35.969 KB
April 01 2020 02:43:18
0 / 0
0755
msghack
12.452 KB
November 27 2019 15:49:53
0 / 0
0755
msginit
44.383 KB
April 01 2020 02:43:18
0 / 0
0755
msgmerge
52.602 KB
April 01 2020 02:43:18
0 / 0
0755
msgunfmt
31.703 KB
April 01 2020 02:43:18
0 / 0
0755
msguniq
19.313 KB
April 01 2020 02:43:18
0 / 0
0755
mv
127.305 KB
November 16 2020 22:24:58
0 / 0
0755
namei
27.945 KB
February 02 2021 16:31:53
0 / 0
0755
ndptool
23.625 KB
August 09 2019 00:25:58
0 / 0
0755
needs-restarting
8.168 KB
May 12 2020 16:27:40
0 / 0
0755
neqn
0.265 KB
June 09 2014 20:17:13
0 / 0
0755
newaliases
242.109 KB
April 01 2020 04:09:09
0 / 0
0755
newaliases.postfix
242.109 KB
April 01 2020 04:09:09
0 / 0
0755
newgidmap
38.086 KB
August 09 2019 02:51:01
0 / 0
0755
newgrp
40.953 KB
August 09 2019 02:51:01
0 / 0
4755
newuidmap
38.063 KB
August 09 2019 02:51:01
0 / 0
0755
nf-ct-add
11.805 KB
August 03 2017 19:48:51
0 / 0
0755
nf-ct-list
15.836 KB
August 03 2017 19:48:51
0 / 0
0755
nf-exp-add
16.211 KB
August 03 2017 19:48:51
0 / 0
0755
nf-exp-delete
15.992 KB
August 03 2017 19:48:51
0 / 0
0755
nf-exp-list
11.805 KB
August 03 2017 19:48:51
0 / 0
0755
nf-log
11.234 KB
August 03 2017 19:48:51
0 / 0
0755
nf-monitor
11.18 KB
August 03 2017 19:48:51
0 / 0
0755
nf-queue
11.273 KB
August 03 2017 19:48:51
0 / 0
0755
ngettext
35.953 KB
April 01 2020 02:43:18
0 / 0
0755
nice
32.32 KB
November 16 2020 22:24:58
0 / 0
0755
nisdomainname
15.414 KB
October 18 2019 16:02:04
0 / 0
0755
nl
40.602 KB
November 16 2020 22:24:58
0 / 0
0755
nl-addr-add
11.648 KB
August 03 2017 19:48:51
0 / 0
0755
nl-addr-delete
11.734 KB
August 03 2017 19:48:51
0 / 0
0755
nl-addr-list
15.875 KB
August 03 2017 19:48:51
0 / 0
0755
nl-class-add
11.695 KB
August 03 2017 19:48:51
0 / 0
0755
nl-class-delete
11.547 KB
August 03 2017 19:48:51
0 / 0
0755
nl-class-list
11.477 KB
August 03 2017 19:48:51
0 / 0
0755
nl-classid-lookup
11.289 KB
August 03 2017 19:48:51
0 / 0
0755
nl-cls-add
11.758 KB
August 03 2017 19:48:51
0 / 0
0755
nl-cls-delete
11.68 KB
August 03 2017 19:48:51
0 / 0
0755
nl-cls-list
11.578 KB
August 03 2017 19:48:51
0 / 0
0755
nl-fib-lookup
11.414 KB
August 03 2017 19:48:51
0 / 0
0755
nl-link-enslave
7.047 KB
August 03 2017 19:48:51
0 / 0
0755
nl-link-ifindex2name
7.063 KB
August 03 2017 19:48:51
0 / 0
0755
nl-link-list
11.523 KB
August 03 2017 19:48:51
0 / 0
0755
nl-link-name2ifindex
7.047 KB
August 03 2017 19:48:51
0 / 0
0755
nl-link-release
7.047 KB
August 03 2017 19:48:51
0 / 0
0755
nl-link-set
11.641 KB
August 03 2017 19:48:51
0 / 0
0755
nl-link-stats
11.391 KB
August 03 2017 19:48:51
0 / 0
0755
nl-list-caches
11.078 KB
August 03 2017 19:48:51
0 / 0
0755
nl-list-sockets
7.063 KB
August 03 2017 19:48:51
0 / 0
0755
nl-monitor
11.195 KB
August 03 2017 19:48:51
0 / 0
0755
nl-neigh-add
11.508 KB
August 03 2017 19:48:51
0 / 0
0755
nl-neigh-delete
11.57 KB
August 03 2017 19:48:51
0 / 0
0755
nl-neigh-list
11.461 KB
August 03 2017 19:48:51
0 / 0
0755
nl-neightbl-list
11.266 KB
August 03 2017 19:48:51
0 / 0
0755
nl-pktloc-lookup
11.359 KB
August 03 2017 19:48:51
0 / 0
0755
nl-qdisc-add
11.602 KB
August 03 2017 19:48:51
0 / 0
0755
nl-qdisc-delete
11.539 KB
August 03 2017 19:48:51
0 / 0
0755
nl-qdisc-list
11.625 KB
August 03 2017 19:48:51
0 / 0
0755
nl-route-add
11.734 KB
August 03 2017 19:48:51
0 / 0
0755
nl-route-delete
15.859 KB
August 03 2017 19:48:51
0 / 0
0755
nl-route-get
11.18 KB
August 03 2017 19:48:51
0 / 0
0755
nl-route-list
11.773 KB
August 03 2017 19:48:51
0 / 0
0755
nl-rule-list
11.297 KB
August 03 2017 19:48:51
0 / 0
0755
nl-tctree-list
11.531 KB
August 03 2017 19:48:51
0 / 0
0755
nl-util-addr
7.031 KB
August 03 2017 19:48:51
0 / 0
0755
nm
45.43 KB
November 01 2021 15:39:15
0 / 0
0755
nm-online
15.164 KB
November 16 2020 16:15:18
0 / 0
0755
nmcli
809.164 KB
November 16 2020 16:15:18
0 / 0
0755
nmtui
646.766 KB
November 16 2020 16:15:18
0 / 0
0755
nmtui-connect
646.766 KB
November 16 2020 16:15:18
0 / 0
0755
nmtui-edit
646.766 KB
November 16 2020 16:15:18
0 / 0
0755
nmtui-hostname
646.766 KB
November 16 2020 16:15:18
0 / 0
0755
nohup
32.422 KB
November 16 2020 22:24:58
0 / 0
0755
nproc
32.367 KB
November 16 2020 22:24:58
0 / 0
0755
nroff
3.313 KB
June 09 2014 20:17:15
0 / 0
0755
nsenter
28.219 KB
February 02 2021 16:31:53
0 / 0
0755
nss-policy-check
15.258 KB
October 19 2023 13:17:47
0 / 0
0755
numfmt
64.711 KB
November 16 2020 22:24:58
0 / 0
0755
objcopy
227.336 KB
November 01 2021 15:39:15
0 / 0
0755
objdump
357.742 KB
November 01 2021 15:39:15
0 / 0
0755
od
64.813 KB
November 16 2020 22:24:58
0 / 0
0755
oldfind
186.406 KB
October 30 2018 16:42:55
0 / 0
0755
open
19.477 KB
November 24 2021 16:34:03
0 / 0
0755
openssl
542.266 KB
March 20 2023 16:13:47
0 / 0
0755
openvt
19.477 KB
November 24 2021 16:34:03
0 / 0
0755
os-prober
5.511 KB
November 06 2016 03:30:02
0 / 0
0755
p11-kit
32.18 KB
August 04 2017 23:36:46
0 / 0
0755
package-cleanup
17.386 KB
May 12 2020 16:27:40
0 / 0
0755
page_owner_sort
10.195 KB
June 04 2024 14:55:42
0 / 0
0755
passwd
27.203 KB
April 01 2020 03:57:19
0 / 0
4755
paste
32.344 KB
November 16 2020 22:24:58
0 / 0
0755
pathchk
32.313 KB
November 16 2020 22:24:58
0 / 0
0755
pchrt
3.93 KB
November 05 2016 21:51:47
0 / 0
0755
perl
11.141 KB
February 02 2021 16:33:17
0 / 0
0755
perl5.16.3
11.141 KB
February 02 2021 16:33:17
0 / 0
0755
perlbug
43.605 KB
February 02 2021 16:32:27
0 / 0
0755
perldoc
0.198 KB
June 10 2014 08:17:48
0 / 0
0755
perlthanks
43.605 KB
February 02 2021 16:32:27
0 / 0
0755
pflags
2.062 KB
August 09 2019 02:08:24
0 / 0
0755
pgawk
418.625 KB
June 28 2017 21:52:48
0 / 0
0755
pgrep
27.672 KB
September 30 2020 17:21:37
0 / 0
0755
phar
14.476 KB
August 02 2023 09:52:03
0 / 0
0755
phar.phar
14.476 KB
August 02 2023 09:52:03
0 / 0
0755
php
4.21 MB
August 02 2023 09:52:19
0 / 0
0755
php-cgi
4.18 MB
August 02 2023 09:52:19
0 / 0
0755
phpize
4.64 KB
August 02 2023 09:52:03
0 / 0
0755
pic
180.406 KB
June 09 2014 20:17:22
0 / 0
0755
piconv
7.985 KB
June 10 2014 02:49:27
0 / 0
0755
pinentry
2.541 KB
November 04 2016 18:02:54
0 / 0
0755
pinentry-curses
49.188 KB
November 05 2016 15:49:27
0 / 0
0755
ping
64.625 KB
August 04 2017 08:01:04
0 / 0
0755
ping6
64.625 KB
August 04 2017 08:01:04
0 / 0
0755
pinky
36.57 KB
November 16 2020 22:24:58
0 / 0
0755
pk12util
103.219 KB
October 19 2023 13:17:47
0 / 0
0755
pkaction
15 KB
January 25 2022 19:42:49
0 / 0
0755
pkcheck
23.031 KB
January 25 2022 19:42:49
0 / 0
0755
pkexec
27.023 KB
January 25 2022 19:42:49
0 / 0
4755
pkg-config
44.383 KB
June 09 2014 22:05:48
0 / 0
0755
pkill
27.672 KB
September 30 2020 17:21:37
0 / 0
0755
pkla-admin-identities
19.227 KB
June 09 2014 22:08:33
0 / 0
0755
pkla-check-authorization
27.305 KB
June 09 2014 22:08:33
0 / 0
0755
pkttyagent
18.984 KB
January 25 2022 19:42:49
0 / 0
0755
pl2pm
4.425 KB
February 02 2021 16:32:02
0 / 0
0755
pldd
14.109 KB
June 04 2024 15:05:31
0 / 0
0755
plymouth
39.766 KB
October 01 2020 16:53:21
0 / 0
0755
pmap
27.609 KB
September 30 2020 17:21:37
0 / 0
0755
pod2html
4 KB
February 02 2021 16:32:27
0 / 0
0755
pod2man
13.263 KB
June 09 2014 19:56:13
0 / 0
0755
pod2text
10.746 KB
June 09 2014 19:56:13
0 / 0
0755
pod2usage
3.667 KB
June 10 2014 08:56:18
0 / 0
0755
post-grohtml
187.547 KB
June 09 2014 20:17:22
0 / 0
0755
powernow-k8-decode
6.148 KB
June 04 2024 14:55:42
0 / 0
0755
pr
65.109 KB
November 16 2020 22:24:58
0 / 0
0755
pre-grohtml
86.242 KB
June 09 2014 20:17:22
0 / 0
0755
preconv
40.883 KB
June 09 2014 20:17:22
0 / 0
0755
printenv
28.281 KB
November 16 2020 22:24:58
0 / 0
0755
printf
48.609 KB
November 16 2020 22:24:58
0 / 0
0755
prlimit
41.195 KB
February 02 2021 16:31:53
0 / 0
0755
ps
97.766 KB
September 30 2020 17:21:37
0 / 0
0755
psed
52.079 KB
February 02 2021 16:32:27
0 / 0
0755
psfaddtable
19.484 KB
November 24 2021 16:34:03
0 / 0
0755
psfgettable
19.484 KB
November 24 2021 16:34:03
0 / 0
0755
psfstriptable
19.484 KB
November 24 2021 16:34:03
0 / 0
0755
psfxtable
19.484 KB
November 24 2021 16:34:03
0 / 0
0755
pstruct
35.749 KB
February 02 2021 16:32:27
0 / 0
0755
ptaskset
3.8 KB
November 05 2016 21:51:47
0 / 0
0755
ptx
65.078 KB
November 16 2020 22:24:58
0 / 0
0755
pwd
32.453 KB
November 16 2020 22:24:58
0 / 0
0755
pwdx
11.266 KB
September 30 2020 17:21:37
0 / 0
0755
pwmake
11.125 KB
April 11 2018 03:58:18
0 / 0
0755
pwscore
11.125 KB
April 11 2018 03:58:18
0 / 0
0755
pydoc
0.076 KB
November 14 2023 16:14:24
0 / 0
0755
python
6.977 KB
November 14 2023 16:14:39
0 / 0
0755
python2
6.977 KB
November 14 2023 16:14:39
0 / 0
0755
python2.7
6.977 KB
November 14 2023 16:14:39
0 / 0
0755
ranlib
61.219 KB
November 01 2021 15:39:15
0 / 0
0755
raw
15.273 KB
February 02 2021 16:31:53
0 / 0
0755
read
0.027 KB
November 24 2021 16:33:26
0 / 0
0755
readelf
509.828 KB
November 01 2021 15:39:15
0 / 0
0755
readlink
40.82 KB
November 16 2020 22:24:58
0 / 0
0755
realpath
61.234 KB
November 16 2020 22:24:58
0 / 0
0755
recode-sr-latin
15.289 KB
April 01 2020 02:43:18
0 / 0
0755
rename
11.258 KB
February 02 2021 16:31:53
0 / 0
0755
renice
11.211 KB
February 02 2021 16:31:53
0 / 0
0755
repo-graph
4.093 KB
May 12 2020 16:27:40
0 / 0
0755
repo-rss
10.073 KB
May 12 2020 16:27:40
0 / 0
0755
repoclosure
11.425 KB
May 12 2020 16:27:40
0 / 0
0755
repodiff
13.966 KB
May 12 2020 16:27:40
0 / 0
0755
repomanage
6.878 KB
May 12 2020 16:27:40
0 / 0
0755
repoquery
55.677 KB
May 12 2020 16:27:40
0 / 0
0755
reposync
14.14 KB
May 12 2020 16:27:40
0 / 0
0755
repotrack
9.864 KB
May 12 2020 16:27:40
0 / 0
0755
reset
19.602 KB
September 06 2017 22:08:20
0 / 0
0755
resizecons
19.625 KB
November 24 2021 16:34:03
0 / 0
0755
rev
11.258 KB
February 02 2021 16:31:53
0 / 0
0755
rm
61.398 KB
November 16 2020 22:24:58
0 / 0
0755
rmail
0.256 KB
April 01 2020 04:08:17
0 / 0
0755
rmail.postfix
0.256 KB
April 01 2020 04:08:17
0 / 0
0755
rmdir
44.461 KB
November 16 2020 22:24:58
0 / 0
0755
rpcgen
90.453 KB
June 04 2024 15:05:31
0 / 0
0755
rpm
15.75 KB
November 24 2021 16:33:34
0 / 0
0755
rpm2cpio
11.156 KB
November 24 2021 16:33:34
0 / 0
0755
rpmdb
11.734 KB
November 24 2021 16:33:34
0 / 0
0755
rpmkeys
11.734 KB
November 24 2021 16:33:34
0 / 0
0755
rpmquery
15.75 KB
November 24 2021 16:33:34
0 / 0
0755
rpmverify
15.75 KB
November 24 2021 16:33:34
0 / 0
0755
rsync
488.375 KB
December 15 2022 16:21:04
0 / 0
0755
rsyslog-recover-qi.pl
5.955 KB
May 31 2022 15:22:17
0 / 0
0755
run-parts
2.037 KB
June 09 2014 22:14:31
0 / 0
0755
runcon
32.469 KB
November 16 2020 22:24:58
0 / 0
0755
rvi
906.445 KB
December 15 2020 16:44:13
0 / 0
0755
rview
906.445 KB
December 15 2020 16:44:13
0 / 0
0755
s2p
52.079 KB
February 02 2021 16:32:27
0 / 0
0755
scp
89.234 KB
August 04 2023 16:00:52
0 / 0
0755
script
19.609 KB
February 02 2021 16:31:53
0 / 0
0755
scriptreplay
15.289 KB
February 02 2021 16:31:53
0 / 0
0755
sdiff
48.406 KB
March 07 2023 14:48:24
0 / 0
0755
secon
24.063 KB
April 01 2020 04:04:55
0 / 0
0755
sed
74.289 KB
September 30 2020 17:35:52
0 / 0
0755
seq
48.477 KB
November 16 2020 22:24:58
0 / 0
0755
setarch
15.273 KB
February 02 2021 16:31:53
0 / 0
0755
setfacl
36.727 KB
April 01 2020 02:16:13
0 / 0
0755
setfont
40.383 KB
November 24 2021 16:34:03
0 / 0
0755
setkeycodes
11.164 KB
November 24 2021 16:34:03
0 / 0
0755
setleds
11.164 KB
November 24 2021 16:34:03
0 / 0
0755
setmetamode
11.211 KB
November 24 2021 16:34:03
0 / 0
0755
setpriv
36.063 KB
February 02 2021 16:31:53
0 / 0
0755
setsid
11.227 KB
February 02 2021 16:31:53
0 / 0
0755
setterm
27.484 KB
February 02 2021 16:31:53
0 / 0
0755
setup-nsssysinit
1.503 KB
October 19 2023 13:17:40
0 / 0
0755
setup-nsssysinit.sh
1.503 KB
October 19 2023 13:17:40
0 / 0
0755
setvtrgb
11.336 KB
November 24 2021 16:34:03
0 / 0
0755
sftp
142.008 KB
August 04 2023 16:00:52
0 / 0
0755
sg
40.953 KB
August 09 2019 02:51:01
0 / 0
4755
sh
941.93 KB
November 24 2021 16:33:27
0 / 0
0755
sha1sum
36.57 KB
November 16 2020 22:24:58
0 / 0
0755
sha224sum
40.633 KB
November 16 2020 22:24:58
0 / 0
0755
sha256sum
40.633 KB
November 16 2020 22:24:58
0 / 0
0755
sha384sum
40.648 KB
November 16 2020 22:24:58
0 / 0
0755
sha512sum
40.648 KB
November 16 2020 22:24:58
0 / 0
0755
show-changed-rco
10.128 KB
May 12 2020 16:27:40
0 / 0
0755
show-installed
16.184 KB
May 12 2020 16:27:40
0 / 0
0755
showconsolefont
15.469 KB
November 24 2021 16:34:03
0 / 0
0755
showkey
15.234 KB
November 24 2021 16:34:03
0 / 0
0755
shred
52.938 KB
November 16 2020 22:24:58
0 / 0
0755
shuf
49.133 KB
November 16 2020 22:24:58
0 / 0
0755
signver
102.602 KB
October 19 2023 13:17:47
0 / 0
0755
size
32.352 KB
November 01 2021 15:39:15
0 / 0
0755
skill
23.617 KB
September 30 2020 17:21:37
0 / 0
0755
slabinfo
34.961 KB
June 04 2024 14:55:42
0 / 0
0755
slabtop
19.516 KB
September 30 2020 17:21:37
0 / 0
0755
sleep
32.352 KB
November 16 2020 22:24:58
0 / 0
0755
slogin
756.398 KB
August 04 2023 16:00:52
0 / 0
0755
snice
23.617 KB
September 30 2020 17:21:37
0 / 0
0755
soelim
32.586 KB
June 09 2014 20:17:22
0 / 0
0755
sort
114.938 KB
November 16 2020 22:24:58
0 / 0
0755
sotruss
4.239 KB
June 04 2024 14:43:52
0 / 0
0755
splain
18.026 KB
February 02 2021 16:32:27
0 / 0
0755
split
69.469 KB
November 16 2020 22:24:58
0 / 0
0755
sprof
22.102 KB
June 04 2024 15:05:31
0 / 0
0755
sqlite3
54.945 KB
January 28 2020 14:24:52
0 / 0
0755
ssh
756.398 KB
August 04 2023 16:00:52
0 / 0
0755
ssh-add
352.461 KB
August 04 2023 16:00:52
0 / 0
0755
ssh-agent
373.25 KB
August 04 2023 16:00:52
0 / 99
2111
ssh-copy-id
10.224 KB
August 04 2023 16:00:49
0 / 0
0755
ssh-keygen
409.383 KB
August 04 2023 16:00:52
0 / 0
0755
ssh-keyscan
430.695 KB
August 04 2023 16:00:52
0 / 0
0755
ssltap
118.414 KB
October 19 2023 13:17:47
0 / 0
0755
stat
77.188 KB
November 16 2020 22:24:58
0 / 0
0755
stdbuf
64.883 KB
November 16 2020 22:24:58
0 / 0
0755
strings
32.547 KB
November 01 2021 15:39:15
0 / 0
0755
strip
227.344 KB
November 01 2021 15:39:15
0 / 0
0755
stty
68.609 KB
November 16 2020 22:24:58
0 / 0
0755
su
31.375 KB
February 02 2021 16:31:53
0 / 0
4755
sudo
147.875 KB
January 25 2023 16:36:33
0 / 0
4111
sudoedit
147.875 KB
January 25 2023 16:36:33
0 / 0
4111
sudoreplay
56.109 KB
January 25 2023 16:36:33
0 / 0
0111
sum
36.555 KB
November 16 2020 22:24:58
0 / 0
0755
sync
28.328 KB
November 16 2020 22:24:58
0 / 0
0755
systemctl
704.797 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-analyze
1.49 MB
December 07 2023 14:51:48
0 / 0
0755
systemd-ask-password
60.375 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-cat
39.984 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-cgls
326.289 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-cgtop
85.086 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-coredumpctl
154.516 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-delta
76.836 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-detect-virt
39.969 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-escape
48.195 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-firstboot
101.516 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-hwdb
85.313 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-inhibit
309.828 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-loginctl
489.617 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-machine-id-setup
52.234 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-notify
48.133 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-nspawn
545.875 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-path
52.156 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-run
387.055 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-stdio-bridge
305.773 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-sysv-convert
3.886 KB
December 07 2023 14:51:20
0 / 0
0755
systemd-tmpfiles
146.133 KB
December 07 2023 14:51:48
0 / 0
0755
systemd-tty-ask-password-agent
84.75 KB
December 07 2023 14:51:48
0 / 0
0755
tabs
15.313 KB
September 06 2017 22:08:20
0 / 0
0755
tac
32.484 KB
November 16 2020 22:24:58
0 / 0
0755
tail
65.25 KB
November 16 2020 22:24:58
0 / 0
0755
tailf
23.883 KB
February 02 2021 16:31:53
0 / 0
0755
tar
338.023 KB
October 30 2018 20:24:30
0 / 0
0755
taskset
32.219 KB
February 02 2021 16:31:53
0 / 0
0755
tbl
115.961 KB
June 09 2014 20:17:22
0 / 0
0755
teamd
155.086 KB
September 30 2020 16:51:47
0 / 0
0755
teamdctl
28.977 KB
September 30 2020 16:51:47
0 / 0
0755
teamnl
19.094 KB
September 30 2020 16:51:47
0 / 0
0755
tee
32.383 KB
November 16 2020 22:24:58
0 / 0
0755
test
36.461 KB
November 16 2020 22:24:58
0 / 0
0755
testgdbm
29.773 KB
June 09 2014 21:39:03
0 / 0
0755
tic
64.258 KB
September 06 2017 22:08:20
0 / 0
0755
timedatectl
330.219 KB
December 07 2023 14:51:48
0 / 0
0755
timeout
53.313 KB
November 16 2020 22:24:58
0 / 0
0755
tload
15.375 KB
September 30 2020 17:21:37
0 / 0
0755
tmon
31.109 KB
June 04 2024 14:55:43
0 / 0
0755
toe
15.43 KB
September 06 2017 22:08:20
0 / 0
0755
top
104.375 KB
September 30 2020 17:21:37
0 / 0
0755
touch
61.023 KB
November 16 2020 22:24:58
0 / 0
0755
tput
15.414 KB
September 06 2017 22:08:20
0 / 0
0755
tr
44.609 KB
November 16 2020 22:24:58
0 / 0
0755
tracepath
15.047 KB
August 04 2017 08:01:04
0 / 0
0755
tracepath6
15.047 KB
August 04 2017 08:01:04
0 / 0
0755
troff
512.961 KB
June 09 2014 20:17:22
0 / 0
0755
true
28.258 KB
November 16 2020 22:24:58
0 / 0
0755
truncate
52.68 KB
November 16 2020 22:24:58
0 / 0
0755
trust
179.078 KB
August 04 2017 23:36:46
0 / 0
0755
tset
19.602 KB
September 06 2017 22:08:20
0 / 0
0755
tsort
36.469 KB
November 16 2020 22:24:58
0 / 0
0755
tty
28.289 KB
November 16 2020 22:24:58
0 / 0
0755
turbostat
113.148 KB
June 04 2024 14:55:42
0 / 0
0755
tzselect
7.167 KB
June 04 2024 14:43:10
0 / 0
0755
udevadm
414.273 KB
December 07 2023 14:51:48
0 / 0
0755
ul
19.469 KB
February 02 2021 16:31:53
0 / 0
0755
umask
0.028 KB
November 24 2021 16:33:26
0 / 0
0755
umount
31.234 KB
February 02 2021 16:31:53
0 / 0
4755
unalias
0.03 KB
November 24 2021 16:33:26
0 / 0
0755
uname
32.297 KB
November 16 2020 22:24:58
0 / 0
0755
unexpand
32.453 KB
November 16 2020 22:24:58
0 / 0
0755
unicode_start
2.495 KB
November 24 2021 16:32:38
0 / 0
0755
unicode_stop
0.354 KB
November 24 2021 16:32:37
0 / 0
0755
uniq
44.711 KB
November 16 2020 22:24:58
0 / 0
0755
unlink
28.305 KB
November 16 2020 22:24:58
0 / 0
0755
unlz4
105.844 KB
September 30 2020 16:55:11
0 / 0
0755
unshare
15.453 KB
February 02 2021 16:31:53
0 / 0
0755
unxz
73.523 KB
June 15 2022 14:40:44
0 / 0
0755
update-ca-trust
1.029 KB
January 13 2022 17:12:22
0 / 0
0755
update-mime-database
52.82 KB
April 01 2020 04:30:55
0 / 0
0755
uptime
11.219 KB
September 30 2020 17:21:37
0 / 0
0755
urlgrabber
12.173 KB
April 01 2020 04:14:03
0 / 0
0755
users
32.422 KB
November 16 2020 22:24:58
0 / 0
0755
usleep
10.945 KB
November 16 2020 16:20:20
0 / 0
0755
usx2yloader
15.406 KB
November 05 2016 18:34:04
0 / 0
0755
utmpdump
15.445 KB
February 02 2021 16:31:53
0 / 0
0755
uuidgen
11.211 KB
February 02 2021 16:31:53
0 / 0
0755
vdir
114.852 KB
November 16 2020 22:24:58
0 / 0
0755
verifytree
10.787 KB
May 12 2020 16:27:40
0 / 0
0755
vi
906.445 KB
December 15 2020 16:44:13
0 / 0
0755
view
906.445 KB
December 15 2020 16:44:13
0 / 0
0755
vlock
15.727 KB
November 24 2021 16:34:03
0 / 0
0755
vmstat
31.477 KB
September 30 2020 17:21:37
0 / 0
0755
vxloader
15.375 KB
November 05 2016 18:34:04
0 / 0
0755
w
19.445 KB
September 30 2020 17:21:37
0 / 0
0755
wait
0.027 KB
November 24 2021 16:33:26
0 / 0
0755
wall
14.984 KB
June 09 2014 23:16:44
0 / 5
2555
watch
24.141 KB
September 30 2020 17:21:37
0 / 0
0755
watchgnupg
15.352 KB
July 13 2018 13:05:25
0 / 0
0755
wc
40.672 KB
November 16 2020 22:24:58
0 / 0
0755
wdctl
40.695 KB
February 02 2021 16:31:53
0 / 0
0755
wget
408.961 KB
May 15 2019 21:01:44
0 / 0
0755
whatis
45.492 KB
October 30 2018 20:26:36
0 / 0
0755
whereis
20.195 KB
February 02 2021 16:31:53
0 / 0
0755
which
23.766 KB
June 10 2014 02:25:22
0 / 0
0755
whiptail
27.836 KB
June 10 2014 07:48:12
0 / 0
0755
who
48.703 KB
November 16 2020 22:24:58
0 / 0
0755
whoami
28.305 KB
November 16 2020 22:24:58
0 / 0
0755
write
19.086 KB
February 02 2021 16:31:53
0 / 5
2755
x86_64
15.273 KB
February 02 2021 16:31:53
0 / 0
0755
x86_64-redhat-linux-gcc
750.594 KB
September 30 2020 02:18:23
0 / 0
0755
x86_energy_perf_policy
10.234 KB
June 04 2024 14:55:42
0 / 0
0755
xargs
60.906 KB
October 30 2018 16:42:55
0 / 0
0755
xgettext
265.352 KB
April 01 2020 02:43:18
0 / 0
0755
xmlcatalog
15.305 KB
October 21 2021 16:15:18
0 / 0
0755
xmllint
61.938 KB
October 21 2021 16:15:18
0 / 0
0755
xmlwf
24 KB
October 06 2022 12:52:33
0 / 0
0755
xsltproc
23.508 KB
September 30 2020 16:56:56
0 / 0
0755
xz
73.523 KB
June 15 2022 14:40:44
0 / 0
0755
xzcat
73.523 KB
June 15 2022 14:40:44
0 / 0
0755
xzcmp
6.477 KB
June 15 2022 14:40:32
0 / 0
0755
xzdec
11.211 KB
June 15 2022 14:40:44
0 / 0
0755
xzdiff
6.477 KB
June 15 2022 14:40:32
0 / 0
0755
xzegrep
5.764 KB
June 15 2022 14:40:32
0 / 0
0755
xzfgrep
5.764 KB
June 15 2022 14:40:32
0 / 0
0755
xzgrep
5.764 KB
June 15 2022 14:40:32
0 / 0
0755
xzless
1.76 KB
June 15 2022 14:40:32
0 / 0
0755
xzmore
2.11 KB
June 15 2022 14:40:32
0 / 0
0755
yes
28.305 KB
November 16 2020 22:24:58
0 / 0
0755
ypdomainname
15.414 KB
October 18 2019 16:02:04
0 / 0
0755
yum
0.782 KB
October 01 2020 17:03:44
0 / 0
0755
yum-builddep
9.95 KB
May 12 2020 16:27:40
0 / 0
0755
yum-config-manager
9.354 KB
May 12 2020 16:27:40
0 / 0
0755
yum-debug-dump
8.338 KB
May 12 2020 16:27:40
0 / 0
0755
yum-debug-restore
7.718 KB
May 12 2020 16:27:40
0 / 0
0755
yum-groups-manager
10.772 KB
May 12 2020 16:27:40
0 / 0
0755
yumdownloader
10.854 KB
May 12 2020 16:27:40
0 / 0
0755
zcat
1.896 KB
May 12 2022 14:58:32
0 / 0
0755
zcmp
1.719 KB
May 12 2022 14:58:32
0 / 0
0755
zdiff
5.633 KB
May 12 2022 14:58:32
0 / 0
0755
zegrep
0.12 KB
May 12 2022 14:58:32
0 / 0
0755
zfgrep
0.12 KB
May 12 2022 14:58:32
0 / 0
0755
zforce
2.094 KB
May 12 2022 14:58:32
0 / 0
0755
zgrep
5.979 KB
May 12 2022 14:58:32
0 / 0
0755
zless
1.993 KB
May 12 2022 14:58:32
0 / 0
0755
zmore
2.792 KB
May 12 2022 14:58:32
0 / 0
0755
znew
5.218 KB
May 12 2022 14:58:32
0 / 0
0755
zsoelim
32.586 KB
June 09 2014 20:17:22
0 / 0
0755
zts-php
4.41 MB
August 02 2023 09:52:19
0 / 0
0755